--[[
    Broker_GarbageFu by LordFarlander
    Version 3.0.30
    $Revision: 30 $

    A conversion of Fubar_GarbageFu by wmrojer
]]--

--[[
Copyright (c) 2008-2011, LordFarlander
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]--

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Broker_GarbageFu" )

local dewdrop = LibStub( "Dewdrop-2.0", true )
if( not dewdrop ) then
    error( L["%s requires %s"]:format( L["GarbageFu"], "Dewdrop-2.0" ) )
    return
end--if

local abacus = LibStub( "LibAbacus-3.0", true )
if( not abacus ) then
    error( L["%s requires %s"]:format( L["GarbageFu"], "LibAbacus-3.0" ) )
    return
end--if

local crayon = LibStub( "LibCrayon-3.0", true )
if( not crayon ) then
    error( L["%s requires %s"]:format( L["GarbageFu"], "LibCrayon-3.0" ) )
    return
end--if

local PT3 = LibStub( "LibPeriodicTable-3.1", true )
if( not PT3 ) then
    error( L["%s requires %s"]:format( L["GarbageFu"], "LibPeriodicTable-3.1" ) )
    return
end--if

local TR = LibStub( "LibLordFarlander-TableRecycler-1.0", true )
if( not TR ) then
    error( L["%s requires %s"]:format( L["GarbageFu"], "LibLordFarlander-TableRecycler-1.0" ) )
    return
end--if

local qtip = LibStub( "LibQTip-1.0", true )
if( not qtip ) then
    error( L["%s requires %s"]:format( L["GarbageFu"], "LibQTip-1.0" ) )
    return
end--if

local LBI = LibStub( "LibBabble-Inventory-3.0" ):GetUnstrictLookupTable()

Broker_GarbageFu = LibStub( "AceAddon-3.0" ):NewAddon( "Broker_GarbageFu", "AceEvent-3.0", "AceHook-3.0", "AceConsole-3.0", "AceTimer-3.0" )
Broker_GarbageFu.version = { major = 3, minor = 0, revision = tonumber( ("$Revision: 30 $"):match( "(%d+)" ) ) }
Broker_GarbageFu.date = ("$Date: 2011-12-24 04:23:38 +0000 (Sat, 24 Dec 2011) $"):sub( 8, 17 )
Broker_GarbageFu.printFrame = DEFAULT_CHAT_FRAME
Broker_GarbageFu.debugFrame = DEFAULT_CHAT_FRAME
Broker_GarbageFu.icon = [[Interface\AddOns\Broker_GarbageFu\img\icon]]

if( not GarbageFu ) then
    --Prentend to be GarbageFu
    --Calls are 100% compatible
    GarbageFu = Broker_GarbageFu
end--if

------------------------------------------------------------------------------------------------------
-- Simple Property functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:UpdateDisplay()
    self:OnTextUpdate()
    self:UpdateTooltip()
end--Broker_GarbageFu:UpdateDisplay()

function Broker_GarbageFu:GetDropThreshold()
    return self.db.profile.threshold
end--Broker_GarbageFu:GetDropThreshold()

function Broker_GarbageFu:IsDropThreshold( value )
    return self.db.profile.threshold == tonumber( value )
end--Broker_GarbageFu:IsDropThreshold( value )

function Broker_GarbageFu:GetMoneyFormat()
    return self.db.profile.moneyformat
end--Broker_GarbageFu:GetMoneyFormat()

function Broker_GarbageFu:GetNameLength( value )
    return self.db.profile.namelength
end--Broker_GarbageFu:GetNameLength( value )

function Broker_GarbageFu:IsIgnoringHerbBag()
    return self.db.profile.ignoreherbbag
end--Broker_GarbageFu:IsIgnoringHerbBag()

function Broker_GarbageFu:IsIgnoringEnchBag()
    return self.db.profile.ignoreenchbag
end--Broker_GarbageFu:IsIgnoringEnchBag()

function Broker_GarbageFu:IsIgnoringEngBag()
    return self.db.profile.ignoreengbag
end--Broker_GarbageFu:IsIgnoringEngBag()

function Broker_GarbageFu:IsIgnoringFishBag()
    return self.db.profile.ignorefishbag
end--Broker_GarbageFu:IsIgnoringFishBag()

function Broker_GarbageFu:IsIgnoringGemBag()
    return self.db.profile.ignoregembag
end--Broker_GarbageFu:IsIgnoringGemBag()

function Broker_GarbageFu:IsIgnoringLeatherBag()
    return self.db.profile.ignoreleatherbag
end--Broker_GarbageFu:IsIgnoringLeatherBag()

function Broker_GarbageFu:IsIgnoringInsBag()
    return self.db.profile.ignoreinsbag
end--Broker_GarbageFu:IsIgnoringInsBag()

function Broker_GarbageFu:IsIgnoringMinBag()
    return self.db.profile.ignoreminbag
end--Broker_GarbageFu:IsIgnoringMinBag()

function Broker_GarbageFu:IsSafeToDelete()
    return self.vars.safedelete
end--Broker_GarbageFu:IsSafeToDelete()

function Broker_GarbageFu:SetSafeToDelete( value )
    self.vars.safedelete = value
end--Broker_GarbageFu:SetSafeToDelete( value )

function Broker_GarbageFu:IsItemIcon()
    return self.db.profile.itemicon
end--Broker_GarbageFu:IsItemIcon()

function Broker_GarbageFu:IsPriceType()
    return self.db.profile.pricetype
end--Broker_GarbageFu:IsPriceType()

function Broker_GarbageFu:IsShowingBagSlots()
    return self.db.profile.showbagslots
end--Broker_GarbageFu:IsShowingBagSlots()

function Broker_GarbageFu:IsShowingTotalValue()
    return self.db.profile.showtotalvalue
end--Broker_GarbageFu:IsShowingTotalValue()

function Broker_GarbageFu:IsShowingFirstDrop()
    return self.db.profile.showfirstdrop
end--Broker_GarbageFu:IsShowingFirstDrop()

function Broker_GarbageFu:IsShowingFreeSlots()
    return self.db.profile.showfreeslots
end--Broker_GarbageFu:IsShowingFreeSlots()

function Broker_GarbageFu:ToggleShowFreeSlots()
    self.db.profile.showfreeslots = not self.db.profile.showfreeslots
    self:OnTextUpdate()
end--Broker_GarbageFu:ToggleShowFreeSlots()

function Broker_GarbageFu:IsShowingTotalSlots()
    return self.db.profile.showtotalslots
end--Broker_GarbageFu:IsShowingTotalSlots()

function Broker_GarbageFu:IsShowingStatistics()
    return self.db.profile.showstatistics
end--Broker_GarbageFu:IsShowingStatistics()

------------------------------------------------------------------------------------------------------
-- A little more complicate property functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:IsDropItem( itemid )
    return type( self.db.profile.dropitem[itemid] ) ~= "nil"
end--Broker_GarbageFu:IsDropItem( itemid )

function Broker_GarbageFu:ToggleDropItem( itemid )
    local profile = self.db.profile
    
    if( profile.dropitem[itemid] ) then
        profile.dropitem[itemid] = nil
    else
        profile.dropitem[itemid] = true
        profile.keepitem[itemid] = nil
    end--if
    self:UpdateDisplay()
end--Broker_GarbageFu:ToggleDropItem( itemid )

function Broker_GarbageFu:IsKeepItem( itemid )
    return type( self.db.profile.keepitem[itemid] ) ~= "nil"
end--Broker_GarbageFu:IsKeepItem( itemid )

function Broker_GarbageFu:ToggleKeepItem( itemid )
    local profile = self.db.profile
    
    if( profile.keepitem[itemid] ) then
        profile.keepitem[itemid] = nil
    else
        profile.keepitem[itemid] = true
        profile.dropitem[itemid] = nil
    end--if
    self:UpdateDisplay()
end--Broker_GarbageFu:ToggleKeepItem( itemid )

------------------------------------------------------------------------------------------------------
-- Constant data
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:InitVars()
    Broker_GarbageFu.vars = {
        moneyformats = {
            { name = L["Condensed"], ex = abacus:FormatMoneyCondensed( 123456, true, true ) },
            { name = L["Short"], ex = abacus:FormatMoneyShort( 123456, true, true ) },
            { name = L["Full"], ex = abacus:FormatMoneyFull( 123456, true, true ) },
            { name = L["Extended"], ex = abacus:FormatMoneyExtended( 123456, true, true) },
        },
        sets = {
            { id = "Consumable.Food", name = LBI["Food"], sub = { -- foodall
                { id = "Consumable.Food.Edible.Basic.Non-Conjured", name = L["Normal Food"], }, -- food
                { id = "Consumable.Food.Edible.Bonus", name = L["Bonus Food"], }, --foodbonus
                { id = "Consumable.Food.Buff", name = L["Stat Food"], }, -- foodstat
                { id = "Consumable.Food.Edible.Combo", name = L["Combo Food"], },
                { id = "Consumable.Food.Edible.Basic.Conjured", name = L["Conjured Bread"], }, -- foodbreadconjured
                { id = "Consumable.Food.Edible.Battleground", name = L["Battleground Bread"], },
                { id = "Consumable.Food.Inedible", name = L["Raw Food"], }, -- foodraw
                { id = "Consumable.Food.Bread", name = L["Bread"], }, -- foodclassbread
                { id = "Consumable.Food.Fish", name = LBI["Fish"], }, -- foodclassfish
                { id = "Consumable.Food.Meat", name = LBI["Meat"], }, -- foodclassmeat
                { id = "Consumable.Food.Cheese", name = L["Cheese"], }, -- foodclasscheese
                { id = "Consumable.Food.Fruit", name = L["Fruit"], }, -- foodclassfruit
                { id = "Consumable.Food.Fungus", name = L["Fungus"], }, -- foodclassfungus
                { id = "Consumable.Food.Misc", name = LBI["Miscellaneous"], },
            }, },
            { id = "Consumable.Water", name = L["Water"], sub = { -- waterall
                { id = "Consumable.Water.Basic", name = L["Normal Water"], }, -- water
                { id = "Consumable.Water.Percentage", name = L["Percent Water"], }, -- waterperc
                { id = "Consumable.Water.Conjured", name = L["Conjured Water"], }, -- waterconjured
                { id = "Consumable.Water.Battleground", name = L["Battleground Water"], },
            }, },
            { id = "Misc.Booze", name = L["Booze"], }, -- booze
            { id = "Tradeskill.Mat.ByProfession", name = L["Tradeskill"], sub = { -- tradeskill
                { id = "Tradeskill.Mat.ByProfession.Alchemy", name = LBI["Alchemy"], }, -- tradeskillalchemy
                { id = "Tradeskill.Mat.ByProfession.Blacksmithing", name = LBI["Blacksmithing"], }, -- tradeskillblacksmithing
                { id = "Tradeskill.Mat.ByProfession.Cooking", name = LBI["Cooking"], }, -- tradeskillcooking
                { id = "Tradeskill.Mat.ByProfession.Enchanting", name = LBI["Enchanting"], }, -- tradeskillenchanting
                { id = "Tradeskill.Mat.ByProfession.Engineering", name = LBI["Engineering"], }, -- tradeskillengineering
                { id = "Tradeskill.Mat.ByProfession.First Aid", name = LBI["First Aid"], }, -- tradeskillfirstaid
                { id = "Tradeskill.Mat.ByProfession.Jewelcrafting", name = LBI["Jewelcrafting"], },
                { id = "Tradeskill.Mat.ByProfession.Leatherworking", name = LBI["Leatherworking"], }, -- tradeskillleatherworking
                { id = "Tradeskill.Mat.ByProfession.Tailoring", name = LBI["Tailoring"], }, -- tradeskilltailoring
                { id = "Tradeskill.Mat.ByProfession.Poisons", name = L["Poison"], }, -- tradeskillpoison
                { id = "Tradeskill.Mat.ByProfession.Smelting", name = L["Smelting"], }, -- tradeskillsmelting
                { id = "Tradeskill.Mat.ByProfession.Inscriptioning", name = LBI["Inscription"], }, -- tradeskillinscriptioning
            }, },
            { id = "Tradeskill.Tool", name = L["Tradeskill Tools"], sub = { -- tradeskilltools
                { id = "Tradeskill.Tool.Alchemy", name = LBI["Alchemy"], },
                { id = "Tradeskill.Tool.Blacksmithing", name = LBI["Blacksmithing"], },
                { id = "Tradeskill.Tool.Enchanting", name = LBI["Enchanting"], },
                { id = "Tradeskill.Tool.Engineering", name = LBI["Engineering"], },
                { id = "Tradeskill.Tool.Fishing", name = LBI["Fishing"], },
                { id = "Tradeskill.Tool.Jewelcrafting", name = LBI["Jewelcrafting"], },
                { id = "Tradeskill.Tool.Mining", name = LBI["Mining"], },
                { id = "Tradeskill.Tool.Skinning", name = LBI["Skinning"], },
                { id = "Tradeskill.Tool.Inscriptioning", name = LBI["Inscriptioning"], },
            }, },
            { id = "Tradeskill.Gather", name = L["Gathered"], sub = { -- gatherskill
                { id = "Tradeskill.Gather.Fishing", name = LBI["Fishing"], }, -- gatherskillfishing
                { id = "Tradeskill.Gather.Disenchant", name = L["Disenchant"], }, -- gatherskilldisenchant
                { id = "Tradeskill.Gather.Herbalism", name = LBI["Herbalism"], }, -- gatherskillherbalism
                { id = "Tradeskill.Gather.Mining", name = LBI["Mining"], }, -- gatherskillmining
                { id = "Tradeskill.Gather.Pickpocketing", name = L["Pickpocketing"], },
                { id = "Tradeskill.Gather.Prospecting", name = L["Prospecting"], },
                { id = "Tradeskill.Gather.Skinning", name = LBI["Skinning"], }, -- gatherskillskinning
            }, },
            { id = "Tradeskill.Recipe", name = LBI["Recipe"], auctionOnly=true, sub = { -- recipe
                { id = "Tradeskill.Recipe.Alchemy", name = LBI["Alchemy"], auctionOnly=true}, -- recipealchemy
                { id = "Tradeskill.Recipe.Blacksmithing", name = LBI["Blacksmithing"], auctionOnly=true}, -- recipeblacksmith
                { id = "Tradeskill.Recipe.Cooking", name = LBI["Cooking"], auctionOnly=true}, -- recipecooking
                { id = "Tradeskill.Recipe.Enchanting", name = LBI["Enchanting"], auctionOnly=true}, -- recipeenchanting
                { id = "Tradeskill.Recipe.Engineering", name = LBI["Engineering"], auctionOnly=true}, -- recipeengineering
                { id = "Tradeskill.Recipe.Fishing", name = LBI["Fishing"], auctionOnly=true}, -- recipefishing
                { id = "Tradeskill.Recipe.First Aid", name = LBI["First Aid"], auctionOnly=true}, -- recipefirstaid
                { id = "Tradeskill.Recipe.Jewelcrafting", name = LBI["Jewelcrafting"], auctionOnly=true},
                { id = "Tradeskill.Recipe.Leatherworking", name = LBI["Leatherworking"], auctionOnly=true}, -- recipeleatherworking
                { id = "Tradeskill.Recipe.Tailoring", name = LBI["Tailoring"], auctionOnly=true}, -- recipetailoring
                { id = "Tradeskill.Recipe.Inscriptioning", name = LBI["Inscription"], auctionOnly=true}, -- recipeinscriptioning
            }, },
            { id = "Consumable.Bandage", name = LBI["Bandage"], }, -- bandages
            { id = "Misc.Engineering.Explosives", name = LBI["Explosives"], }, -- explosives
            { id = "QuestMats.Darkmoon Faire", name = L["Darkmoon Faire"], }, -- faire
            { id = "Misc.Engineering.Fireworks", name = L["Fireworks"], }, -- fireworks
            { id = "Consumable.Potion", name = LBI["Potion"], sub = { -- potionall
                { id = "Consumable.Potion.Recovery.Healing", name = L["Heal Potions"], }, -- potionhealall
                { id = "Consumable.Potion.Recovery.Mana", name = L["Mana Potions"], }, -- potionmanaall
                { id = "Consumable.Buff.Rage.Self", name = L["Rage Potions"], }, -- potionrage
                { id = "Consumable.Potion.Other.Cure", name = L["Cure Potions"], }, -- potioncure
                { id = "Consumable.Potion.Buff", name = L["Buff Potions"], }, -- potionbuff
            }, },
            { id = "Consumable.Scroll", name = LBI["Scroll"], }, -- scrolls
            { id = "Reagent.Class", name = LBI["Reagent"], sub = { -- reagent
                { id = "Reagent.Class.Paladin", name = LBI["Paladin"], }, -- reagentpaladin
                { id = "Reagent.Class.Druid", name = LBI["Druid"], }, -- reagentdruid
                { id = "Reagent.Class.Mage", name = LBI["Mage"], }, -- reagentmage
                { id = "Reagent.Class.Priest", name = LBI["Priest"], }, -- reagentpriest
                { id = "Reagent.Class.Rogue", name = LBI["Rogue"], }, -- reagentrogue
                { id = "Reagent.Class.Shaman", name = LBI["Shaman"], }, -- reagentshaman
                { id = "Reagent.Class.Warlock", name = LBI["Warlock"], }, -- reagentwarlock
                { id = "Reagent.Class.DeathKnight", name = LBI["Death Knight"], }, -- reagentdeathknight
            }, },
            { id = "Consumable.Weapon Buff", name = LBI["Weapon Enchantment"], sub = { -- weapontempenchants
                { id = "Consumable.Weapon Buff.Poison", name = L["Poisons"], }, -- poisons
                { id = "Consumable.Weapon Buff.Oil", name = L["Oil"], },
                { id = "Consumable.Weapon Buff.Stone", name = L["Stones"], },
            }, },
            { id = "Misc.Mount", name = LBI["Mounts"], }, -- mounts
            { id = "Misc.Minipet", name = LBI["Companions"], }, -- minipetall
        },
        converttbl= {
            ["foodall"] = "Consumable.Food",
            ["food"] = "Consumable.Food.Edible.Basic.Non-Conjured",
            ["foodbonus"] = "Consumable.Food.Edible.Bonus",
            ["foodstat"] = "Consumable.Food.Buff",
            ["foodbreadconjured"] = "Consumable.Food.Edible.Basic.Conjured",
            ["foodraw"] = "Consumable.Food.Inedible",
            ["foodclassbread"] = "Consumable.Food.Bread",
            ["foodclassfish"] = "Consumable.Food.Fish",
            ["foodclassmeat"] = "Consumable.Food.Meat",
            ["foodclasscheese"] = "Consumable.Food.Cheese",
            ["foodclassfruit"] = "Consumable.Food.Fruit",
            ["foodclassfungus"] = "Consumable.Food.Fungus",
            ["waterall"] = "Consumable.Water",
            ["water"] = "Consumable.Water.Basic",
            ["waterperc"] = "Consumable.Water.Percentage",
            ["waterconjured"] = "Consumable.Water.Conjured",
            ["booze"] = "Misc.Booze",
            ["tradeskill"] = "Tradeskill.Mat.ByProfession",
            ["tradeskillalchemy"] = "Tradeskill.Mat.ByProfession.Alchemy",
            ["tradeskillblacksmithing"] = "Tradeskill.Mat.ByProfession.Blacksmithing",
            ["tradeskillcooking"] = "Tradeskill.Mat.ByProfession.Cooking",
            ["tradeskillenchanting"] = "Tradeskill.Mat.ByProfession.Enchanting",
            ["tradeskillengineering"] = "Tradeskill.Mat.ByProfession.Engineering",
            ["tradeskillfirstaid"] = "Tradeskill.Mat.ByProfession.First Aid",
            ["tradeskillleatherworking"] = "Tradeskill.Mat.ByProfession.Leatherworking",
            ["tradeskilltailoring"] = "Tradeskill.Mat.ByProfession.Tailoring",
            ["tradeskillpoison"] = "Tradeskill.Mat.ByProfession.Poisons",
            ["tradeskillsmelting"] = "Tradeskill.Mat.ByProfession.Smelting",
            ["tradeskilltools"] = "Tradeskill.Tool",
            ["gatherskill"] = "Tradeskill.Gather",
            ["gatherskillfishing"] = "Tradeskill.Gather.Fishing",
            ["gatherskilldisenchant"] = "Tradeskill.Gather.Disenchant",
            ["gatherskillherbalism"] = "Tradeskill.Gather.Herbalism",
            ["gatherskillmining"] = "Tradeskill.Gather.Mining",
            ["gatherskillskinning"] = "Tradeskill.Gather.Skinning",
            ["recipe"] = "Tradeskill.Recipe",
            ["recipealchemy"] = "Tradeskill.Recipe.Alchemy",
            ["recipeblacksmith"] = "Tradeskill.Recipe.Blacksmithing",
            ["recipecooking"] = "Tradeskill.Recipe.Cooking",
            ["recipeenchanting"] = "Tradeskill.Recipe.Enchanting",
            ["recipeengineering"] = "Tradeskill.Recipe.Engineering",
            ["recipefishing"] = "Tradeskill.Recipe.Fishing",
            ["recipefirstaid"] = "Tradeskill.Recipe.First Aid",
            ["recipeleatherworking"] = "Tradeskill.Recipe.Leatherworking",
            ["recipetailoring"] = "Tradeskill.Recipe.Tailoring",
            ["bandages"] = "Consumable.Bandage",
            ["explosives"] = "Misc.Engineering.Explosives",
            ["faire"] = "QuestMats.Darkmoon Faire",
            ["fireworks"] = "Misc.Engineering.Fireworks",
            ["potionall"] = "Consumable.Potion",
            ["potionhealall"] = "Consumable.Potion.Recovery.Healing",
            ["potionmanaall"] = "Consumable.Potion.Recovery.Mana",
            ["potionrage"] = "Consumable.Buff.Rage.Self",
            ["potioncure"] = "Consumable.Potion.Other.Cure",
            ["potionbuff"] = "Consumable.Potion.Buff",
            ["scrolls"] = "Consumable.Scroll",
            ["reagent"] = "Reagent.Class",
            ["reagentpaladin"] = "Reagent.Class.Paladin",
            ["reagentdruid"] = "Reagent.Class.Druid",
            ["reagentmage"] = "Reagent.Class.Mage",
            ["reagentpriest"] = "Reagent.Class.Priest",
            ["reagentrogue"] = "Reagent.Class.Rogue",
            ["reagentshaman"] = "Reagent.Class.Shaman",
            ["reagentwarlock"] = "Reagent.Class.Warlock",
            ["weapontempenchants"] = "Consumable.Weapon Buff",
            ["poisons"] = "Consumable.Weapon Buff.Poison",
            ["mounts"] = "Misc.Mount",
            ["minipetall"] = "Misc.Minipet",
        },
        --[[
            slot = { -- [type]
                "link", -- [string] itemLink for the item occupying this slot
                "stack", -- [number] stack count of the item occupying this slot
            }
        ]]
        --[[
            bag = { -- [type]
                "numSlots", -- [number] number of slots
                "bagName",  -- [string] localized item name of the bag
                "ignore",   -- [boolean] if true this bag should not be scanned
                -- [index], list of type "slot" by slot index up to "numSlots"
            }
        ]]
        bags = {}, -- list of all bags as type "bag" indexed on the bag's bagId
        --[[
            item = { -- [type]
                -- item location and number of items
                "bag",      -- [number] bagId that this item occupies
                "slot",     -- [number] slot position that this item occupies in the bag
                "stack",    -- [number] number of items in the stack
                "totvalue", -- [number] total value in gold of the stack
                -- item information
                "id",       -- [number] itemId for the item
                "link",     -- [string] itemLink for this item
                "code",     -- [string] itemString for this item
                "tex",      -- [string] item texture
                "bind",     -- [string] how does the item bind:
                              -- "S" = soulbound,
                              -- "P" = bind on pickup,
                              -- "E" = bind on use or equip,
                              -- "A" = bind on account,
                              -- "Q" = quest item,
                "quality",  -- [number] the quality of the item; 0 = poor etc
                "maxstack", -- [number] maximum stack size for the item
                "type",     -- [id] auction type of the item, index into itemtypes
                "subtype",  -- [id] auction subtype of the item, index into itemtypes[type]
                "value",    -- [number] value in gold of the item
                "notseen",  -- [boolean] if true this item is in the cache
            }
        ]]
        items = {}, -- list of all items in all bags as type "item"
        pricecache = {},
        auctioncache = {},
        colors = {},
        keepsets = {},
        dropsets = {},
        temptbl = {},
    }
end--Broker_GarbageFu:InitVars()

------------------------------------------------------------------------------------------------------
-- FuBar required functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:OnInitialize()
    local AceConfigReg = LibStub( "AceConfigRegistry-3.0" )
    local AceConfigDialog = LibStub( "AceConfigDialog-3.0" )
    local defaults = {
        profile = {
            moneyformat = 1,
            namelength = 32,
            ignoresoulbag = false,
            ignoreherbbag = false,
            ignoreenchbag = false,
            ignoreengbag = false,
            ignorefishbag = false,
            ignoregembag = false,
            ignoreminbag = false,
            ignoreleatherbag = false,
            ignoreinsbag = false,
            sellallbutton = true,
            sellonlygrey = true,
            sellonopen = false,
            pricetype = false,
            garbageprices = true,
            itemicon = false,
            showtotalvalue = false,
            showfirstdrop = true,
            showbagslots = true,
            showtotalslots = true,
            showfreeslots = true,
            showstatistics = true,
            textcolor = { r = 0.2, g = 0.8, b = 1.0 },
            threshold = 0,
            dropsets = {},
            dropitem = {},
            keepsets = {},
            keepitem = {},
            droptypes = {},
            keeptypes = {},
            auctionsets = {},
            auctionitem = {},
            auctioncache = {},
            auctionThreshold = 3,
            auctionaddonsorder = {},
            vendoraddonsorder = {},
        },
        global = {
            overrideprices = {},
        },
        realm = {
            auctioncache = {},
            --    Added by Scott set default for Total value of garbage items dropped
            garbagedropped = { ["*"] = 0 },
            --    Added by Scott set default for Total value of garbage items sold
            garbageprofit = { ["*"] = 0 },
        },
    }
    local options = {
        type = "group",
        handler = self,
        args = {
            dropthreshold = {
                type = "select",
                order = 1,
                name = L["Drop Threshold"],
                desc = L["Drop Threshold"],
                values = function( info )
                             local values = {}

                             for a = 0, 7 do
                                 values[a] = info.handler.vars.colors[a].hex .. info.handler.vars.colors[a].desc .. "|r"
                             end--for
                             return values
                         end,
                get  = "GetDropThreshold",
                set  = function( info, value )
                           info.handler.db.profile.threshold = value
                           info.handler:UpdateDisplay()
                       end,
            },
            moneyformat = {
                type = "select",
                order = 2,
                name = L["Money Format"],
                desc = L["Money Format"],
                values = function( info )
                             local values = {}

                             for a, f in ipairs( info.handler.vars.moneyformats ) do
                                 values[a] = f.name .. "\t" .. f.ex
                             end--for
                             return values
                         end,
                get = "GetMoneyFormat",
                set = function( info, value )
                          info.handler.db.profile.moneyformat = value
                          info.handler:UpdateDisplay()
                      end,
            },
            namelength = {
                type = "range",
                order = 3,
                name = L["Max Item Name Length"],
                desc = L["Max Item Name Length"],
                min = 5,
                max = 32,
                bigStep = 1,
                get  = "GetNameLength",
                set  = function( info, value )
                           info.handler.db.profile.namelength = value
                           info.handler:OnTextUpdate()
                       end,
            },
            itemicon = {
                type = "toggle",
                order = 4,
                name = L["Use Items Icon on Toolbar"],
                desc = L["Use Items Icon on Toolbar"],
                get  = "IsItemIcon",
                set  = function( info, value )
                           info.handler.db.profile.itemicon = value
                           if( not value ) then
                               info.handler.ldbobj.icon = [[Interface\AddOns\Broker_GarbageFu\Icon]]
                           else
                               info.handler:OnTextUpdate()
                           end--if
                       end,
            },
            showbagslots = {
                type = "toggle",
                order = 5,
                name = L["Show Bag slots on Toolbar"],
                desc = L["Show Bag slots on Toolbar"],
                get  = "IsShowingBagSlots",
                set  = function( info, value )
                           info.handler.db.profile.showbagslots = value
                           info.handler:OnTextUpdate()
                       end,
            },
            showtotalslots = {
                type = "toggle",
                order = 6,
                name = L["Show Total slots"],
                desc = L["Show Total slots"],
                get  = "IsShowingTotalSlots",
                set  = function( info, value )
                           info.handler.db.profile.showtotalslots = value
                           info.handler:OnTextUpdate()
                       end,
            },
            totalvalue = {
                type = "toggle",
                order = 7,
                name = L["Show Total Garbage Value on Toolbar"],
                desc = L["Show Total Garbage Value on Toolbar"],
                get  = "IsShowingTotalValue",
                set  = function( info, value )
                           info.handler.db.profile.showtotalvalue = value
                           info.handler:OnTextUpdate()
                       end,
            },
            firstdrop = {
                type = "toggle",
                order = 8,
                name = L["Show First Drop Item on Toolbar"],
                desc = L["Show First Drop Item on Toolbar"],
                get  = "IsShowingFirstDrop",
                set  = function( info, value )
                           info.handler.db.profile.showfirstdrop = value
                           info.handler:OnTextUpdate()
                       end,
            },
            pricetype = {
                type = "toggle",
                order = 9,
                name = L["Show Price Type in Tooltip"],
                desc = L["Show Price Type in Tooltip"],
                get  = "IsPriceType",
                set  = function( info, value )
                           info.handler.db.profile.pricetype = value
                           info.handler:UpdateTooltip()
                       end,
            },
            statistics = {
                type = "toggle",
                order = 10,
                name = L["Show Statistics"],
                desc = L["Show Statistics"],
                get  = "IsShowingStatistics",
                set  = function( info, value )
                           info.handler.db.profile.showstatistics = value
                       end,
            },
            rescan = {
                type = "execute",
                order = 11,
                name = L["Rescan Prices"],
                desc = L["RescanPricesDesc"],
                func = "UpdateAllItemValues",
            },
            reset = {
                type = "execute",
                order = 12,
                name = L["Reset"],
                desc = L["ResetDesc"],
                func = function()
                           StaticPopup_Show( "BROKER_GARBAGEFU_RESET" )
                       end,
            },
        },
    }
    local bagoptions = {
        type = "group",
        handler = self,
        name = L["Special Bags"],
        args = {
            ignoreherbbag = {
                type = "toggle",
                order = 1,
                name = L["Ignore Herb Bags"],
                desc = L["Ignore Herb Bags"],
                get  = "IsIgnoringHerbBag",
                set  = function( info, value )
                           self.db.profile.ignoreherbbag = value
                           self:InitBagScan()
                       end,
            },
            ignoreengbag = {
                type = "toggle",
                order = 2,
                name = L["Ignore Engineering Bags"],
                desc = L["Ignore Engineering Bags"],
                get  = "IsIgnoringEngBag",
                set  = function( info, value )
                           self.db.profile.ignoreengbag = value
                           self:InitBagScan()
                       end,
            },
            ignorefishbag = {
                type = "toggle",
                order = 3,
                name = L["Ignore Fishing Bags"],
                desc = L["Ignore Fishing Bags"],
                get  = "IsIgnoringFishBag",
                set  = function( info, value )
                           self.db.profile.ignorefishbag = value
                           self:InitBagScan()
                       end,
            },
            ignoregembag = {
                type = "toggle",
                order = 4,
                name = L["Ignore Gem Bags"],
                desc = L["Ignore Gem Bags"],
                get  = "IsIgnoringGemBag",
                set  = function( info, value )
                           self.db.profile.ignoregembag = value
                           self:InitBagScan()
                       end,
            },
            ignoreinsbag = {
                type = "toggle",
                order = 5,
                name = L["Ignore Inscription Bags"],
                desc = L["Ignore Inscription Bags"],
                get  = "IsIgnoringInsBag",
                set  = function( info, value )
                           self.db.profile.ignoreinsbag = value
                           self:InitBagScan()
                       end,
            },
            ignoreleatherbag = {
                type = "toggle",
                order = 6,
                name = L["Ignore Leatherworking Bags"],
                desc = L["Ignore Leatherworking Bags"],
                get  = "IsIgnoringLeatherBag",
                set  = function( info, value )
                           self.db.profile.ignoreleatherbag = value
                           self:InitBagScan()
                       end,
            },
            ignoreminbag = {
                type = "toggle",
                order = 7,
                name = L["Ignore Mining Bags"],
                desc = L["Ignore Mining Bags"],
                get  = "IsIgnoringMinBag",
                set  = function( info, value )
                           self.db.profile.ignoreminbag = value
                           self:InitBagScan()
                       end,
            },
        },
    }

    if( GarbageFu ) then
        options.args.copysettings = {
            type = "execute",
            order = -1,
            name = L["Copy setting from FuBar_GarbageFu"],
            desc = L["Copy setting from FuBar_GarbageFu"],
            func = "CopySettingsFromFuBar_GarbageFu",
        }
    end--if

--             self:BuildSellOptionsMenu( level - 1, value, inTooltip, value2 )
--             self:BuildVendorOptionMenu( level - 1, value, inTooltip, value2 )
--             self:BuildAuctionOptionMenu( level - 1, value, inTooltip, value2 )

    self:InitVars()

    self.db = LibStub( "AceDB-3.0" ):New( "Broker_GarbageFuDB", defaults )

    local profileOptions = LibStub( "AceDBOptions-3.0" ):GetOptionsTable( self.db )

    self.db.RegisterCallback( self, "OnProfileChanged" )
    self.db.RegisterCallback( self, "OnProfileReset" )

    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Main Options", options )
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Bag Options", bagoptions )
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Sell Options", self:BuildSellOptionsGroup() )
--    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Price Options", self:BuildPriceOptionsGroup() )
--    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Auction Options", self:BuildAuctionOptionsGroup() )
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Profile", profileOptions )
    self.vars.blizOptionsId = AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Main Options", L["GarbageFu"] )
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Bag Options", L["Special Bags"], L["GarbageFu"] )
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Sell Options", L["Sell"], L["GarbageFu"] )
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Profile", L["Profile"], L["GarbageFu"] )

    -- Put stuff that only neeeds to be done once here
    -- Get Item quality colors
    
    local colors = self.vars.colors
    
    for i = 0, 7 do
        colors[i] = {
            desc = _G[("ITEM_QUALITY%d_DESC"):format( i )],
        }
        colors[i].r, colors[i].g, colors[i].b, colors[i].hex = GetItemQualityColor( i )
        colors[i].hex = "|c" .. colors[i].hex
    end
    -- Create Static dialog for Reset Settings
    StaticPopupDialogs["BROKER_GARBAGEFU_RESET"] = {
          text = L["Are you sure you want to reset all your settings for GarbageFU?"],
          button1 = TEXT( ACCEPT ),
          button2 = TEXT( CANCEL ),
          OnAccept = function()
                         Broker_GarbageFu.SettingsReset( self )
                     end,
          timeout = 0,
          whileDead = 1,
          hideOnEscape = 1,
    }
    if( not GarbageFu ) then
        GarbageFu = self
    end--if

    self.ldbobj = LibStub( "LibDataBroker-1.1" ):NewDataObject( L["GarbageFu"], {
            type = "data source",
            icon = self.icon,
            label = L["GarbageFu"],
            text = L["GarbageFu"], -- To get Button Bin to work correctly when autohiding text
            OnClick = function( _, button )
                          self:OnClick( button )
                      end,
            OnEnter = function( frame )
                          local tooltip = qtip:Acquire( "Broker_GarbageFu_Tooltip", 3, "LEFT", "CENTER", "RIGHT" )

                          self.vars.frame = frame
                          self.vars.tooltip = tooltip
                          tooltip:EnableMouse( true )
                          tooltip:SmartAnchorTo( frame )
                          self:UpdateTooltip()
                          tooltip:Show()
                      end,
            OnLeave = function( frame )
                          local function HideTooltip()
                              if( MouseIsOver( self.vars.tooltip ) ) then
                                  return
                              end
                              self.vars.tooltip:SetScript( "OnLeave", nil )
                              self.vars.tooltip:Hide()
                              qtip:Release( self.vars.tooltip )
                              self.vars.tooltip = nil
                          end--HideTooltip()

                          if( self.vars.tooltip ) then
                              if( MouseIsOver( self.vars.tooltip ) ) then
                                  self.vars.tooltip:SetScript( "OnLeave", HideTooltip )
                              else
                                  HideTooltip()
                              end--if
                          end--if
                      end,
        } )

    self.vars.initialized = true
    self:InitTypes()
    self:InitVendor()
--    self:InitAuction()
    
    -- Check for any needed upgrades of settings
    self:CheckSettings()
    self.db.profile.LastWoWVersion = tonumber( select( 4, GetBuildInfo() ) )
    -- Store AddOn version. In case we need to check it in the future for upgrades.
    self.db.profile.LastVersion = self.version
    
    self:UpdateAllItemValues()
    self:Update()
end--Broker_GarbageFu:OnInitialize()

function Broker_GarbageFu:CopySettingsFromFuBar_GarbageFu()
    if( GarbageFu == self ) then
        return
    end--if

    local function DeleteAll( table )
        for i, _ in pairs( table ) do
            table[i] = nil
        end--if
    end--function DeleteAll( table )
    local function CopyTable( to, from )
        for i, v in pairs( from ) do
            if( type( v ) == "table" ) then
                to[i] = {}
                CopyTable( to[i], v )
            else
                to[i] = v
            end--if
        end--for
    end--CopyTable( to, from )

    DeleteAll( self.db.profile )
    DeleteAll( self.db.realm )
    DeleteAll( self.db.global )
    CopyTable( self.db.profile, GarbageFu.db.profile )
    CopyTable( self.db.realm, GarbageFu.db.realm )
    CopyTable( self.db.global, GarbageFu.db.account )
end--Broker_GarbageFu:CopySettingsFromFuBar_GarbageFu()

function Broker_GarbageFu:OnEnable()
    -- Stuff that needs to be done every time the mod is enabled
    self:SetSafeToDelete( false )
    if( self.vars.initialized )then
        self:InitTypes()
        self:InitVendor()
--        self:InitAuction()
    end--if
    self:MainInit()
    self:OnEnteringWorld()
    self:SetSafeToDelete( true )
end--Broker_GarbageFu:OnEnable()

function Broker_GarbageFu:OnDisable()
    self:SetSafeToDelete( false )
    self:HideSellAllButton()
    self:OnLeavingWorld()
end--Broker_GarbageFu:OnDisable()

function Broker_GarbageFu:OnProfileReset()
    self:OnProfileChanged()
end--Broker_GarbageFu:OnProfileReset()

function Broker_GarbageFu:OnProfileChanged()
    self:CheckSettings()
    if( self.vars.initialized ) then
        self:MainInit()
    end -- Reload all the settings if the profile was changed after we entered the world.
end--Broker_GarbageFu:OnProfileEnable()

function Broker_GarbageFu:OnEnteringWorld()
    self:RegisterEvent( "BAG_UPDATE", "OnBagUpdate" )
    self:RegisterEvent( "MERCHANT_SHOW", "OnMerchantOpen")
    self:RegisterEvent( "MERCHANT_CLOSED", "OnMerchantClose" )
    self:RegisterEvent( "ADDON_LOADED", "OnAddOnLoaded" )
    self:RegisterEvent( "PLAYER_LEAVING_WORLD", "OnLeavingWorld" )
    self:RegisterEvent( "GET_ITEM_INFO_RECEIVED", "OnItemInfoRecieved" )
    self:UnregisterEvent( "PLAYER_ENTERING_WORLD" )
    if( not self.vars.UpdateTimerHandle ) then
        self.vars.UpdateTimerHandle = self:ScheduleRepeatingTimer( "Update", 2 )
    end--if
end--Broker_GarbageFu:OnEnteringWorld()

function Broker_GarbageFu:OnLeavingWorld()
    self:RegisterEvent( "PLAYER_ENTERING_WORLD", "OnEnteringWorld" )
    self:UnregisterEvent( "BAG_UPDATE" )
    self:UnregisterEvent( "MERCHANT_SHOW" )
    self:UnregisterEvent( "MERCHANT_CLOSED" )
    self:UnregisterEvent( "ADDON_LOADED" )
    self:UnregisterEvent( "PLAYER_LEAVING_WORLD" )
    self:UnregisterEvent( "GET_ITEM_INFO_RECEIVED" )
    if( self.vars.UpdateTimerHandle ) then
        self:CancelTimer( self.vars.UpdateTimerHandle )
        self.vars.UpdateTimerHandle = nil
    end--if
end--Broker_GarbageFu:OnLeavingWorld()

function Broker_GarbageFu:Update()
    self:OnTextUpdate()
    self:UpdateTooltip()
end--Broker_GarbageFu:Update()

function Broker_GarbageFu:UpdateTooltip()
    if( self.vars.tooltip ) then
        self:OnTooltipUpdate()
    end--if
end--Broker_GarbageFu:UpdateTooltip()

function Broker_GarbageFu:OnTextUpdate()
    local vars = self.vars

    if( not vars.initialized ) then
        return
    end--if

    local text = ""

    if( self:IsShowingBagSlots() ) then
        text = self:GetBagSlots()
    end--if
    if( self:IsShowingTotalValue() ) then
        local total = 0
        local IsItemDroppable = self.IsItemDroppable

        for i, item in ipairs( vars.items ) do
            if( IsItemDroppable( self, item ) ) then
                total = total + item.totvalue
            end--if
        end--for
        if( total > 0 ) then
            text = text .. self:GetMoneyString( total ) .. " "
        end--if
    end--if
    if( self:IsShowingFirstDrop() ) then
        local item = self:GetFirstDroppableItem()

        if( item ) then
            if( item.name:len() > self:GetNameLength() ) then
                text = text .. vars.colors[item.qual].hex .. item.name:sub( 1, self:GetNameLength() - 2 ) .. " .. " .. "|r"
            else
                text = text .. vars.colors[item.qual].hex .. item.name .. "|r"
            end--if
            if( item.maxstack > 1 ) then
                text = text .. " |cffffff00" .. tostring( item.stack ) .. "|r"
            end--if
            text = text .. " " .. self:GetMoneyString( item.totvalue )
            if( self:IsItemIcon() ) then
               self.ldbobj.icon = item.tex
            end--if
        else
            if( self:IsItemIcon() ) then
                self.ldbobj.icon = self.icon
            end--if
            text = text .. "|cff777777" .. L["No items to drop"] .. "|r"
        end--if
    end--if
    self.ldbobj.text = text
    self:HighlightSellAllButton()
end--Broker_GarbageFu:OnTextUpdate()

function Broker_GarbageFu:OnTooltipUpdate()
    local vars = self.vars
    
    if( not vars.initialized ) then
        return
    end--if

    local tooltip = vars.tooltip
    local AddLine = tooltip.AddLine
    local SetCell = tooltip.SetCell
    local SetLineScript = tooltip.SetLineScript
    local HeaderFont = tooltip:GetHeaderFont()
    local line, column
    local total = 0
    local items = 0
    local colors = vars.colors
    local IsPriceType = self:IsPriceType()
    local GetMoneyString = self.GetMoneyString
    local IsItemDroppable = self.IsItemDroppable
    local dropItemFunction = function( arg ) class:OnClickItem( arg ) end

    tooltip:Clear()
    line, column = AddLine( tooltip )
    line, column = SetCell( tooltip, line, column, L["GarbageFu"], HeaderFont, nil, tooltip:GetColumnCount() )
    line, column = AddLine( tooltip )
    line, column = SetCell( tooltip, line, column, " " )

    for _, item in ipairs( vars.items ) do
        if( IsItemDroppable( self, item ) ) then
            local stacktext = "|r"

            if( item.maxstack > 1 ) then
                stacktext = stacktext .. ("|r |cffffff00(%i/%i)|r |r |cffffff00"):format( item.stack, item.maxstack )
            end--if
            total = total + item.totvalue
            items = items + 1
            line, column = AddLine( tooltip )
            if( IsPriceType ) then
    -- self:SetScript( "OnEnter", function( self )
                                   -- if( not self.highlight ) then
                                       -- self.highlight = self:CreateTexture( nil, "BACKGROUND" )
                                       -- self.highlight:Hide()
                                   -- end--if
                                   -- self.highlight:SetTexture( [[Interface\QuestFrame\UI-QuestTitleHighlight]] )
                                   -- self.highlight:SetBlendMode( "ADD" )
                                   -- self.highlight:SetAllPoints( self )
                                   -- self.highlight:Show()
                               -- end )
    -- self:SetScript( "OnLeave", function( self )
                                   -- self.highlight:ClearAllPoints()
                                   -- self.highlight:Hide()
                               -- end )
                line, column = SetCell( tooltip, line, column, colors[item.qual].hex .. item.name .. stacktext )
                line, column = SetCell( tooltip, line, column, GetMoneyString( self, item.totvalue ) )
                line, column = SetCell( tooltip, line, column, item.pricetype )
            else
                line, column = SetCell( tooltip, line, column, colors[item.qual].hex .. item.name .. stacktext, nil, nil, -1 )
                line, column = SetCell( tooltip, line, column, GetMoneyString( self, item.totvalue ), nil, "RIGHT" )
            end--if
            SetLineScript( tooltip, line, dropItemFunction, item )
        end--if
    end--for
    if( items > 1 ) then
        line, column = AddLine( tooltip )
        line, column = SetCell( tooltip, line, column, L["Total"], nil, "RIGHT", -1 )
        line, column = SetCell( tooltip, line, column, GetMoneyString( self, total ), nil, "RIGHT" )
    end--if
    if( self:IsShowingStatistics() ) then
        --    Added by Scott Calculate total of all garbage items sold and display
        local total = 0
        local garbageprofit = self.db.realm.garbageprofit
        local garbagedropped = self.db.realm.garbagedropped

        line, column = AddLine( tooltip )
        line, column = SetCell( tooltip, line, column, "|CFF99FF99" .. L["BankedProfit"], nil, nil, tooltip:GetColumnCount() )
        if( ( next( garbageprofit ) ~= UnitName( "player" ) ) or next( garbageprofit, UnitName( "player" ) ) ) then
            local t = TR:GetTable()

            for name in pairs( garbageprofit ) do
                tinsert( t, name )
            end--for
            if( not self.sort_func ) then
                self.sort_func = function( alpha, bravo )
                                     return garbageprofit[alpha] < garbageprofit[bravo]
                                 end
            end--if
            table.sort( t, self.sort_func )
            for _, name in ipairs( t ) do
                local value = garbageprofit[name]

                line, column = AddLine( tooltip )
                line, column = SetCell( tooltip, line, column, name, nil, "RIGHT", -1 )
                line, column = SetCell( tooltip, line, column, GetMoneyString( self, value ), nil, "RIGHT" )
                total = total + value
            end--for
            TR:ReturnTable( t )
        else
            total = garbageprofit[UnitName( "player" )]
        end--if
        line, column = AddLine( tooltip )
        line, column = SetCell( tooltip, line, column, "|CFF99FF99" .. L["Total Profit"], nil, "RIGHT", -1 )
        line, column = SetCell( tooltip, line, column, GetMoneyString( self, total ), nil, "RIGHT" )
        --    Added by Scott Calculate total of all garbage items dropped and display

        local total = 0

        line, column = AddLine( tooltip )
        line, column = SetCell( tooltip, line, column, "|CFF99FF99" .. L["DroppedProfit"], nil, nil, tooltip:GetColumnCount() )
        if( ( next( garbagedropped ) ~= UnitName( "player" ) ) or next( garbagedropped, UnitName( "player" ) ) ) then
            local t = TR:GetTable()

            for name in pairs( garbagedropped ) do
                tinsert( t, name )
            end--for
            if( not self.sort_func ) then
                self.sort_func = function( alpha, bravo )
                                     return garbagedropped[alpha] < garbagedropped[bravo]
                                 end
            end--if
            table.sort( t, self.sort_func )
            for _, name in ipairs( t ) do
                local value = garbagedropped[name]

                line, column = AddLine( tooltip )
                line, column = SetCell( tooltip, line, column, name, nil, "RIGHT", -1 )
                line, column = SetCell( tooltip, line, column, GetMoneyString( self, value ), nil, "RIGHT" )
                total = total + value
            end--for
            TR:ReturnTable( t )
        else
            total = garbagedropped[UnitName( "player" )]
        end--if
        line, column = AddLine( tooltip )
        line, column = SetCell( tooltip, line, column, "|CFF99FF99" .. L["Total Loss"], nil, "RIGHT", -1 )
        line, column = SetCell( tooltip, line, column, GetMoneyString( self, total ), nil, "RIGHT" )
    end--if

    if( MerchantFrame:IsVisible() ) then
        if( self:IsShowingFirstDrop() ) then
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, " ", nil, nil, tooltip:GetColumnCount() )
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, L["Hint1_item"] .. "\n" .. L["Hint1"], HeaderFont, nil, tooltip:GetColumnCount() )
        else
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, " ", nil, nil, tooltip:GetColumnCount() )
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, "\n" .. L["Hint1"], HeaderFont, nil, tooltip:GetColumnCount() )
        end--if
    else
        if( self:IsShowingFirstDrop() ) then
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, " ", nil, nil, tooltip:GetColumnCount() )
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, L["Hint2_item"] .. "\n" .. L["Hint2"], HeaderFont, nil, tooltip:GetColumnCount() )
        else
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, " ", nil, nil, tooltip:GetColumnCount() )
            line, column = AddLine( tooltip )
            line, column = SetCell( tooltip, line, column, "\n" .. L["Hint2"], HeaderFont, nil, tooltip:GetColumnCount() )
        end--if
    end--if
end--Broker_GarbageFu:OnTooltipUpdate()

function Broker_GarbageFu:OnMenuRequest( level, value, inTooltip, value2, value3 )
    local vars = self.vars
    
    if( not vars.initialized ) then
        return
    end--if
    
    local AddLine = dewdrop.AddLine
    local sets = vars.sets
    
    if( level == 1 ) then
        local item = self:GetFirstDroppableItem()

        if( item ) then
            local text = vars.colors[item.qual].hex .. item.name .. "|r"

            if( item.maxstack > 1 ) then
                text = text .. " |cffffff00x" .. tostring( item.stack ) .. "|r"
            end--if
            AddLine( dewdrop, "text", text .. " " .. self:GetMoneyString( item.totvalue ),
                "notClickable", true, "checked", true, "checkIcon", item.tex )

            local text = MerchantFrame:IsVisible() and L["Sell this item"] or L["Drop this item"]

            AddLine( dewdrop, "text", text, "arg1", self, "func", "DropFirstItem", "tooltipTitle", text,
                "tooltipText", L["Drops this item, or sells it if the vendor window is open"] )
            if( item.qual > 0 ) then
                AddLine( dewdrop, "text", L["Keep this item"], "arg1", self, "func", "KeepFirstItem",
                    "tooltipTitle", L["Keep this item"], "tooltipText", L["Adds this item to the keep items list"])
            end--if
            self:BuildSellMenu( level, value, inTooltip, value2 )
            if( ( item.qual > 0 ) or ( item.totvalue == 0 ) or self.db.global.overrideprices[item.id] ) then
                AddLine( dewdrop, "text", L["Edit value for this item"], "hasArrow", true,
                    "hasEditBox", true, "editBoxText", tostring( item.value ),
                    "editBoxArg1", self, "editBoxFunc", self.SetFirstItemValue,
                    "editBoxChangeArg1", self, "editBoxChangeFunc", self.ValidateValue,
                    "tooltipTitle", L["Edit value for this item"], "tooltipText", L["Value TooltipText"] )
            end--if
            AddLine( dewdrop, "" )
        end--if
        AddLine( dewdrop, "text", L["Drop"], "hasArrow", true, "value", "drop" )
        AddLine( dewdrop, "text", L["Keep"], "hasArrow", true, "value", "keep" )
--        self:BuildAuctionMenu( level, value, inTooltip, value2 )
        AddLine( dewdrop, "text", L["Edit item values"], "hasArrow", true, "value", "itemvalue" )
        AddLine( dewdrop, "" )
        AddLine( dewdrop, "text", L["Options"], "hasArrow", true, "value", "options" )
    elseif( level == 2 ) then
        if( value == "drop" ) then
            AddLine( dewdrop, "text", L["Drop"], "isTitle", true )
            AddLine( dewdrop, "text", L["Drop Sets"], "hasArrow", true, "value", "dropsets" )
            self:BuildDropTypeMenu( level - 1, value, inTooltip, value2 )
            AddLine( dewdrop, "text", L["Drop Items"], "hasArrow", true, "value", "dropitem" )
        elseif( value == "keep" ) then
            AddLine( dewdrop, "text", L["Keep"], "isTitle", true )
            AddLine( dewdrop, "text", L["Keep Sets"], "hasArrow", true, "value", "keepsets" )
            self:BuildKeepTypeMenu( level - 1, value, inTooltip, value2 )
            AddLine( dewdrop, "text", L["Keep Items"], "hasArrow", true, "value", "keepitem" )
        elseif( value == "itemvalue" ) then
            -- Edit item values
            AddLine( dewdrop, "text", L["Edit item values"], "isTitle", true )

            local tbl = self:GetCustomItemValueTable()
            local colors = vars.colors
            local SetItemValue = self.SetItemValue
            local ValidateValue = self.ValidateValue
            local overrideprices = self.db.global.overrideprices

            for _, i in ipairs( tbl ) do
                AddLine( dewdrop, "text", colors[i.qual].hex .. i.name,
                    "checked", overrideprices[i.id] ~= nil, "hasArrow", true, "hasEditBox", true,
                    "editBoxText", tostring( i.value ),
                    "editBoxArg1", self, "editBoxArg2", i.id, "editBoxFunc", SetItemValue,
                    "editBoxChangeArg1", self, "editBoxChangeFunc", ValidateValue,
                    "tooltipTitle", L["Edit value for this item"], "tooltipText", L["Value TooltipText"] )
            end--for
            --tbl = nil
        elseif( value == "options" ) then
            self:BuildVendorOptionMenu( level - 1, value, inTooltip, value2 )
--            self:BuildAuctionOptionMenu( level - 1, value, inTooltip, value2 )
            AddLine( dewdrop, "" )
        else
--            self:BuildAuctionMenu( level, value, inTooltip, value2 )
        end--if
    elseif( level == 3 ) then
        if( value2 == "drop" ) then
            if( value == "dropsets" ) then
                -- Drop - Sets
                local IsChildDropSetSelected = self.IsChildDropSetSelected
                local IsKeepSetSelected = self.IsKeepSetSelected
                local IsDropSetSelected = self.IsDropSetSelected
                
                AddLine( dewdrop, "text", L["Drop Sets"], "isTitle", true )
                for n, i in ipairs( sets ) do
                    if( not i.auctionOnly ) then
                        local checked = IsDropSetSelected( self, n )
                        local checkIcon = [[Interface\Buttons\UI-CheckBox-Check]]

                        if( IsChildDropSetSelected( self, n ) ) then
                            checked = true
                            checkIcon = [[Interface\Buttons\UI-CheckBox-Check-Disabled]]
                        end--if
                        AddLine( dewdrop, "text", i.name,
                            "checked", checked, "checkIcon", checkIcon,
                            "disabled", IsKeepSetSelected( self, n ),
                            "hasArrow", i.sub ~= nil, "value", n,
                            "arg1", self, "arg2", n, "func", "ToggleDropSet" )
                    end--if
                end--for
            elseif( value == "dropitem" ) then
                -- Drop - Items
                local tbl = self:GetDropItemAndItemTable()
                local lastChar = ""
                local breakUp = false
                local IsDropItem = self.IsDropItem
                local colors = vars.colors

                AddLine( dewdrop, "text", L["Drop Items"], "isTitle", true )

                breakUp = #tbl > 30
                for _, i in ipairs( tbl ) do
                    if( breakUp ) then
                        local startChar = i.name:sub( 1, 1 )

                        if( startChar ~= lastChar ) then
                            lastChar = startChar
                            AddLine( dewdrop, "text", startChar, "hasArrow", true, "value", startChar )
                        end--if
                    else
                        AddLine( dewdrop, "text", colors[i.qual].hex .. i.name,
                                         "checked", IsDropItem( self, i.id ),
                                         "arg1", self, "arg2", i.id, "func", "ToggleDropItem" )
                    end--if
                end--for
            else
                self:BuildDropTypeMenu( level - 1, value, inTooltip, value2 )
            end--if
        elseif( value2 == "keep" ) then
            if( value == "keepsets" ) then
                -- Keep - Sets
                local IsDropSetSelected = self.IsDropSetSelected
                local IsKeepSetSelected = self.IsKeepSetSelected
                local IsChildKeepSetSelected = self.IsChildKeepSetSelected
                
                AddLine( dewdrop, "text", L["Keep Sets"], "isTitle", true )
                for n, i in ipairs( sets ) do
                    if( not i.auctionOnly ) then
                        local checked = IsKeepSetSelected( self, n )
                        local checkIcon = [[Interface\Buttons\UI-CheckBox-Check]]

                        if( IsChildKeepSetSelected( self, n ) ) then
                            checked = true
                            checkIcon = [[Interface\Buttons\UI-CheckBox-Check-Disabled]]
                        end--if
                        AddLine( dewdrop, "text", i.name,
                            "checked", checked, "checkIcon", checkIcon,
                            "disabled", IsDropSetSelected( self, n ),
                            "hasArrow", i.sub ~= nil, "value", n,
                            "arg1", self, "arg2", n, "func", "ToggleKeepSet" )
                    end--if
                end--for
            elseif( value == "keepitem" ) then
                -- Keep - Items
                local tbl = self:GetKeepItemTable()
                local lastChar = ""
                local breakUp = false
                local IsKeepItem = self.IsKeepItem
                local colors = vars.colors

                AddLine( dewdrop, "text", L["Keep Items"], "isTitle", true )

                breakUp = #tbl > 30
                for _, i in ipairs( tbl ) do
                    if( breakUp ) then
                        local startChar = i.name:sub( 1, 1 )

                        if( startChar ~= lastChar ) then
                            lastChar = startChar
                            AddLine( dewdrop, "text", startChar, "hasArrow", true, "value", startChar )
                        end--if
                    else
                        AddLine( dewdrop, "text", colors[i.qual].hex .. i.name,
                                         "checked", IsKeepItem( self, i.id ),
                                         "arg1", self, "arg2", i.id, "func", "ToggleKeepItem" )
                    end--if
                end--for
            else
                self:BuildKeepTypeMenu( level - 1, value, inTooltip, value2 )
            end--if
        elseif( value2 == "options" ) then
            self:BuildVendorOptionMenu( level - 1, value, inTooltip, value2 )
--            self:BuildAuctionOptionMenu( level - 1, value, inTooltip, value2 )
        else
--            self:BuildAuctionMenu( level, value, inTooltip, value2 )
        end--if
    elseif( level == 4 ) then
        if( value2 == "dropsets" ) then
            local IsDropSetSelected = self.IsDropSetSelected
            local IsKeepSetSelected = self.IsKeepSetSelected
            
            AddLine( dewdrop, "text", L["Drop Set"] .. " " .. sets[value].name, "isTitle", true )
            for n, i in ipairs( sets[value].sub ) do
                if( not i.auctionOnly ) then
                    AddLine( dewdrop, "text", i.name,
                        "checked", IsDropSetSelected( self, value, n ),
                        "disabled",IsKeepSetSelected( self, value, n ),
                        "arg1", self, "arg2", value, "arg3", n, "func", "ToggleDropSet" )
                end--if
            end--for
        elseif( value2 == "keepsets" ) then
            local IsDropSetSelected = self.IsDropSetSelected
            local IsKeepSetSelected = self.IsKeepSetSelected
            
            AddLine( dewdrop, "text", L["Keep Set"] .. " " .. sets[value].name, "isTitle", true )
            for n, i in ipairs( sets[value].sub ) do
                if( not i.auctionOnly ) then
                    AddLine( dewdrop, "text", i.name,
                        "checked", IsKeepSetSelected( self, value, n ),
                        "disabled", IsDropSetSelected( self, value, n ),
                        "arg1", self, "arg2", value, "arg3", n, "func", "ToggleKeepSet" )
                end--if
            end--for
        elseif( value2 == "dropitem" ) then
            local tbl = self:GetDropItemTable()
            local IsDropItem = self.IsDropItem
            local colors = vars.colors

            for _, i in ipairs( tbl ) do
                if( i.name:sub( 1, 1 ) == value ) then
                    AddLine( dewdrop, "text", colors[i.qual].hex .. i.name,
                                     "checked", IsDropItem( self, i.id ),
                                     "arg1", self, "arg2", i.id, "func", "ToggleDropItem" )
                end--if
            end--for
        elseif( value2 == "keepitem" ) then
            local tbl = self:GetKeepItemTable()
            local IsKeepItem = self.IsKeepItem
            local colors = vars.colors

            for _, i in ipairs( tbl ) do
                if( i.name:sub( 1, 1 ) == value ) then
                    AddLine( dewdrop, "text", colors[i.qual].hex .. i.name,
                                     "checked", IsKeepItem( self, i.id ),
                                     "arg1", self, "arg2", i.id, "func", "ToggleKeepItem" )
                end--if
            end--for
        else
            self:BuildDropTypeMenu( level - 1, value, inTooltip, value2 )
            self:BuildKeepTypeMenu( level - 1, value, inTooltip, value2 )
--            self:BuildAuctionMenu( level, value, inTooltip, value2 )
        end--if
    end--if
end--Broker_GarbageFu:OnMenuRequest( level, value, inTooltip, value2, value3 )

function Broker_GarbageFu:OnClick( button )
    local vars = self.vars
    
    if( not vars.initialized ) then
        return
    end--if
    if( button == "RightButton" ) then
        if( vars.tooltip ) then
            vars.tooltip:SetScript( "OnLeave", nil )
            qtip:Release( vars.tooltip )
            vars.tooltip = nil
        end--if
        dewdrop:Register( vars.frame,
            "children", function( level, value, valueN_1, valueN_2, valueN_3, valueN_4 )
                            if( level == 1 ) then
                                dewdrop:AddLine(
                                    "text", L["GarbageFu"],
                                    "isTitle", true )
                                self:OnMenuRequest( level, value, false, valueN_1, valueN_2, valueN_3, valueN_4 )
                                dewdrop:AddLine(
                                    "text", CLOSE,
                                    "tooltipTitle", CLOSE,
                                    "tooltipText", CLOSE_DESC,
                                    "func", dewdrop.Close,
                                    "arg1", dewdrop )
                            else
                                self:OnMenuRequest( level, value, false, valueN_1, valueN_2, valueN_3, valueN_4 )
                            end--if
                        end,
            "point", function( frame )
                         local x, y = vars.frame:GetCenter()
                         local leftRight

                         if( x < GetScreenWidth() / 2 ) then
                             leftRight = "LEFT"
                         else
                             leftRight = "RIGHT"
                         end--if
                         if( y < GetScreenHeight() / 2 ) then
                             return "BOTTOM" .. leftRight, "TOP" .. leftRight
                         else
                             return "TOP" .. leftRight, "BOTTOM" .. leftRight
                         end--if
                    end,
            "dontHook", true )

        dewdrop:Open( vars.frame, "cursorX", true, "cursorY", true )
        return
    end--if
    if( IsShiftKeyDown() and self:IsShowingFirstDrop() ) then
        self:DropFirstItem()
        return
    end--if
    if( IsControlKeyDown() ) then
        self:KeepFirstItem()
        return
    end--if
    -- Support OneBag
    if( OneBag ) then
        OneBag:ToggleBag( 0 )
        return
    end--if
    if( Baggins ) then
        Baggins:ToggleAllBags()
        return
    end--if
    if( not ContainerFrame1:IsShown() ) then
        ToggleBackpack()
        
        local bags = vars.bags
        
        for i = 1, NUM_BAG_SLOTS do
            if( ( not bags[i].ignore ) and ( bags[i].numSlots > 0 ) and ( not _G["ContainerFrame" .. ( i + 1 )]:IsShown() ) ) then
                ToggleBag( i )
            end--if
        end--for
    else
        for i = 0, NUM_BAG_SLOTS do
            if( _G["ContainerFrame" .. ( i + 1 )]:IsShown() ) then
                _G["ContainerFrame" .. ( i + 1 )]:Hide()
            end--if
        end--for
    end--if
end--Broker_GarbageFu:OnClick( button )
------------------------------------------------------------------------------------------------------
-- Event functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:OnClickItem( item )
    if( IsShiftKeyDown() ) then
        self:DropItem( item )
    end--if
    if( IsControlKeyDown() ) then
        self:KeepItem( item )
    end--if
end--Broker_GarbageFu:OnClickItem( item )

function Broker_GarbageFu:OnMerchantOpen()
    self:HighlightSellAllButton()
    if( self.db.profile.sellonopen and ( not IsModifierKeyDown() ) ) then
        self:SellAllItems()
    end--if
end--Broker_GarbageFu:OnMerchantOpen()

function Broker_GarbageFu:OnMerchantClose()
    self:StopSelling()
end--Broker_GarbageFu:OnMerchantClose()

function Broker_GarbageFu:OnAddOnLoaded( _, addon )
--    self:CheckAuctionAddonLoaded( addon )
    self:CheckVendorAddonLoaded( addon )
end--Broker_GarbageFu:OnAddOnLoaded( addon )

function Broker_GarbageFu:OnBagUpdate( _, bagId )
    self:DebugPrint( "OnBagUpdate bagId=" .. tostring( bagId ) )
    if( not( bagId ) or ( bagId < 0 ) or ( bagId > NUM_BAG_SLOTS ) ) then
        return
    end--if

    local bag = self.vars.bags[bagId]

    if( bag.bagName ~= GetBagName( bagId ) ) then
        self:DebugPrint( "New or changed bag detected. Doing a full scan" )
        self:InitBagScan() -- New or changed bag detected. Do a full scan
        return
    end--if
    if( bag.ignore ) then
        return
    end--if
    self:SetSafeToDelete( false )
    
    local UpdateItem = self.UpdateItem
    local resort = false
    
    for slotId = 1, bag.numSlots do
        local slot = bag[slotId]

        if( not bag[slotId] ) then
            bag[slotId] = TR:GetTable()
            slot = bag[slotId]
        end--if

        local link = GetContainerItemLink( bagId, slotId )
        local _, stack = GetContainerItemInfo( bagId, slotId )

        if( ( link ~= slot.link ) or ( stack ~= slot.stack ) ) then
            slot.link = link
            slot.stack = stack
            UpdateItem( self, bagId, slotId )
            resort = true
        end--if
    end--for
    if( resort ) then
        -- TODO: Does sorting do us any good?
        self:SortItems()
    end--if
    self:SetSafeToDelete( true )
end--Broker_GarbageFu:OnBagUpdate( bag )

function Broker_GarbageFu:OnItemInfoRecieved()
    -- Reattempt to get info for any items that are incomplete
    local vars = self.vars
    
    if( vars.itemRequestPending ) then
        local found = false
        local GetItemType = self.GetItemType
        local GetItemValue = self.GetItemValue
        
        vars.itemRequestPending = nil
        self:SetSafeToDelete( false )
        for _, item in ipairs( self.vars.items ) do
            if( item.notseen ) then
                item.id, item.code, item.name = self:GetItemId( item.link )
                if( item.id ) then
                    GetItemType( self, item )
                    if( item.qual ) then
                        item.notseen = nil
                        GetItemValue( self, item )
                        found = true
                    end--if
                end--if
            end--if
            if( item.notseen ) then
                vars.itemRequestPending = true
            end--if
        end--for
        if( found ) then
            -- TODO: Does sorting do us any good?
            self:SortItems()
        end--if
        self:SetSafeToDelete( true )
    end--if
end--Broker_GarbageFu:OnItemInfoRecieved()

------------------------------------------------------------------------------------------------------
-- Core functions
------------------------------------------------------------------------------------------------------

--
function Broker_GarbageFu:MainInit()
    self:MakeSetsTables()
    self:InitBagScan()
    self:InitSell()
end--Broker_GarbageFu:MainInit()

function Broker_GarbageFu:InitBagScan()
    self:SetSafeToDelete( false )

    local vars = self.vars
    local bags = vars.bags
    local ClearTable = TR.ClearTable
    local GetTable = TR.GetTable
    local UpdateItem = self.UpdateItem
    
    ClearTable( TR, vars.items )
    for bagId = 0, NUM_BAG_SLOTS do
        local bag = bags[bagId]

        if( bag ) then
            ClearTable( TR, bag )
            bag.numSlots = GetContainerNumSlots( bagId )
            bag.bagName = GetBagName( bagId )
            bag.ignore = self:IgnoreBag( bagId )
        else
            bags[bagId] = GetTable( TR,
                "numSlots", GetContainerNumSlots( bagId ),
                "bagName", GetBagName( bagId ),
                "ignore", self:IgnoreBag( bagId ) )
            bag = bags[bagId]
        end--if

        if( not bag.ignore ) then
            for slot = 1, bag.numSlots do
                bag[slot] = GetTable( TR, "link", GetContainerItemLink( bagId, slot ) )
                _, bag[slot].stack = GetContainerItemInfo( bagId, slot )
                UpdateItem( self, bagId, slot )
            end--for
        end--if
    end--for
    self:SortItems()
    self:SetSafeToDelete( true )
end--Broker_GarbageFu:InitBagScan()

function Broker_GarbageFu:UpdateItem( bagId, slotId )
    local itemidx = nil
    local item = nil

    vars = self.vars

    for a, i in ipairs( vars.items ) do
        if( ( i.bag == bagId ) and ( i.slot == slotId ) ) then
            itemidx = a
            item = i
            break
        end--if
    end--for

    local bag = vars.bags[bagId]
    local slot = bag and bag[slotId]

    if( slot and slot.link ) then
        if( not( item ) or ( item.link ~= slot.link ) ) then  -- New or changed item
            if( item ) then
                -- Clear all old values
                table.wipe( item )
                item.bag = bagId
                item.slot = slotId
                item.link = slot.link
                item.stack = slot.stack
            else
                -- Create a new item
                item = TR:GetTable(
                    "bag", bagId,
                    "slot", slotId,
                    "link", slot.link,
                    "stack", slot.stack )
            end--if

            item.id, item.code, item.name = self:GetItemId( item.link )
            if( item.id ) then
                self:GetItemType( item )
                if( not item.qual ) then --- Item not in local cache
                    _, _, item.qual = GetItemInfo( item.id )
                    item.tex = [[Interface\Icons\INV_Misc_QuestionMark.blp]]
                    item.maxstack = 0
                    item.notseen = true
                    vars.itemRequestPending = true
                else
                    item.notseen = nil
                end--if
                self:GetItemValue( item )
            else
                item.notseen = true
                vars.itemRequestPending = true
            end--if
            self:DebugPrint( "New item:%s bag:%d slot:%d", item.name, item.bag, item.slot )
        else -- Just new stack size, recalc totvalue
            item.stack = slot.stack
            if( item.value ) then
                item.totvalue = item.value * item.stack
            end
            self:DebugPrint( "Item stack updated:%s bag:%d slot:%d", item.name, item.bag, item.slot )
        end--if
        if( not itemidx ) then
            tinsert( vars.items, item )  -- New item added
        end--if
    elseif( itemidx ) then
        self:DebugPrint( "Item removed:%s bag:%d slot:%d", item.name, item.bag, item.slot )
        TR:ReturnTable( table.remove( vars.items, itemidx ) ) -- Item removed
    end--if
end--Broker_GarbageFu:UpdateItem( bagId, slotId )

function Broker_GarbageFu:SortItems()
    table.sort( self.vars.items, function( item1, item2 )
                                     return ( ( not item1.notseen ) and ( item2.notseen or ( item1.totvalue < item2.totvalue ) or ( ( item1.totvalue == item2.totvalue ) and ( item1.id < item2.id ) ) ) )
                                 end )
    self:UpdateDisplay()
end--Broker_GarbageFu:SortItems()

function Broker_GarbageFu:GetItemId( link )
    if( link ) then
        local _, _, color, code, id, name = link:find( "|cff(%x%x%x%x%x%x)|Hitem:((%d+):%d+:%d+:%d+:%d+:%d+:%-?%d+:%-?%d+).+%[(.+)%]" )

        return tonumber( id ), code, name, color
    end--if
    return nil
end--Broker_GarbageFu:GetItemId( link )

-- Check if an item is elegiable for drop
function Broker_GarbageFu:IsItemDroppable( item )
    if( item.notseen ) then
        return false -- Still not seen.
    end--if
    if( ( item.totvalue == 0 ) and ( item.qual > 0 ) ) then
       return false -- All items above poor quality without price is not dropped for saftey reasons
    end--if
    if( self:IsItemKeepItem( item.id ) ) then
        return false
    end--if
    if( self:IsItemDropItem( item.id ) ) then
        return true
    end--if
    if( self:IsItemKeepType( item ) ) then
        return false
    end--if
    if( self:IsItemInKeepSets( item.id ) ) then
        return false
    end--if
    if( self:IsItemDropType( item ) ) then
        return true
    end--if
    if( self:IsItemInDropSets( item.id ) ) then
        return true
    end--if
    if( item.qual <= self:GetDropThreshold() ) then
        return true
    end--if
    return false
end--Broker_GarbageFu:IsItemDroppable( item )

function Broker_GarbageFu:GetFirstDroppableItem()
    local IsItemDroppable = self.IsItemDroppable
    
    for i, item in ipairs( self.vars.items ) do
        if( IsItemDroppable( self, item ) ) then
            return item
        end--if
    end--for
    return nil
end--Broker_GarbageFu:GetFirstDroppableItem()

function Broker_GarbageFu:GetBagSlots()
    local total = 0
    local used = 0
    local bags = self.vars.bags

    for bagId = 0, NUM_BAG_SLOTS do
        local bag = bags[bagId]

        if( bag and not( bag.ignore ) ) then
            total = total + bag.numSlots
            for slot = 1, bag.numSlots do
                if( bag[slot] and bag[slot].link ) then
                    used = used + 1
                end--if
            end--for
        end--if
    end--for

    local color = crayon:GetThresholdHexColor( ( total - used ) / total )

    if( self:IsShowingTotalSlots() ) then
        if( self:IsShowingFreeSlots() ) then
            used = total - used
        end--if
        return ("|cff%s%d/%d|r "):format( color, used, total )
    else
        if( self:IsShowingFreeSlots() ) then
            used = total - used
        end--if
        return ("|cff%s%d|r "):format( color, used )
    end--if
end--Broker_GarbageFu:GetBagSlots()

-- Upgrades user settings
function Broker_GarbageFu:CheckSettings()
    local vars = self.vars
    -- Make a list of all valid sets id's
    local hash = TR:GetTable()

    for _, set in ipairs( vars.sets ) do
        if( set.auctionOnly ) then
            hash[set.id] = 2
        else
            hash[set.id] = 1
        end--if
        if( set.sub ) then
            for _, subset in ipairs( set.sub ) do
                if( subset.auctionOnly ) then
                    hash[subset.id] = 2
                else
                    hash[subset.id] = 1
                end--if
            end--for
        end--if
    end--for

    local profile = self.db.profile
    local dropsets = profile.dropsets
    local keepsets = profile.keepsets
    local auctionsets = profile.auctionsets

    self:UpgradeSetNames( dropsets )
    self:UpgradeSetNames( keepsets )
    self:UpgradeSetNames( auctionsets )
    -- Check dropsets
    for setid, _ in pairs( dropsets ) do
        if( ( not hash[setid] ) or ( hash[setid] ~= 1 ) ) then
            dropsets[setid] = nil        -- Deleteing invalid setid
        end--if
    end--for
    -- Check keepsets
    for setid, _ in pairs( keepsets ) do
        if( ( not hash[setid] ) or ( hash[setid] ~= 1 ) ) then
            keepsets[setid] = nil        -- Deleteing invalid setid
        end--if
    end--for
    -- check auctionsets
    for setid, _ in pairs( auctionsets ) do
        if( not hash[setid] ) then
            auctionsets[setid] = nil        -- Deleteing invalid setid
        end--if
    end--for
    TR:ReturnTable( hash )
    -- check vendor addons
    for _, addon in pairs( profile.vendoraddonsorder ) do
        if( not vars.vendoraddons[addon] ) then
            profile.vendoraddonsorder[addon] = nil
        end--if
    end--for
    -- check auction addons
--    for _, addon in pairs( profile.auctionaddonsorder ) do
--        if( not vars.auctionaddons[addon] ) then
--            profile.auctionaddonsorder[addon] = nil
--        end--if
--    end--for
end--Broker_GarbageFu:CheckSettings()

-- Upgrade set names for PT3
function Broker_GarbageFu:UpgradeSetNames( profileset )
    -- Only process if the major or minor version has changed
    
    local LastVersion = self.db.profile.LastVersion
    local version = self.version
    
    if( not( LastVersion ) or
        ( LastVersion.major ~= version.major ) or ( LastVersion.minor ~= version.minor ) ) then
        local converttbl = self.vars.converttbl
        local TypeUpgradeSetName = self.TypeUpgradeSetName

        for setid in pairs( profileset ) do
            local convertSetid = converttbl[setid]
            
            if( convertSetid ) then
                profileset[convertSetid] = true
            else
                TypeUpgradeSetName( self, setid, profileset )
            end--if
        end--for
    end--if
end--Broker_GarbageFu:UpgradeSetNames( profileset )

-- Check that all items match what's actually in the bags
function Broker_GarbageFu:CheckBags()
    local failed = false
    local CheckItem = self.CheckItem

    for i, item in ipairs( self.vars.items ) do
        if( not CheckItem( self, item ) ) then
            failed = true
            break
        end--if
    end--for
    if( failed ) then
        self:Print( "Item inconsistency found. Doing a complete rescan. Please report the errors along with what you did the last minute before it happened." )
        self:InitBagScan()
    end--if
end--Broker_GarbageFu:CheckBags()

-- Check that the item we have is the same as WoW says is in that slot.
function Broker_GarbageFu:CheckItem( item )
    if( not ( item and item.link and item.bag and item.slot ) ) then
        return false
    end--if

    local link = GetContainerItemLink( item.bag, item.slot )

    if( item.link == link ) then
        return true
    end--if
    self:MyPrint( "Error! Expected item %s in bag %d slot %d, but found %s", item.link, item.bag, item.slot, link )
    return false
end--Broker_GarbageFu:CheckItem( item )
------------------------------------------------------------------------------------------------------
-- Drop down menu functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:GetDropItemTable( )
    local vars = self.vars
    local temptbl = vars.temptbl

    TR:ClearTable( temptbl )

    local tbl2 = TR:GetTable()
    local GetTable = TR.GetTable
    local ReturnTable = TR.ReturnTable

    -- Start with itemid's listed as drop
    for i, _ in pairs( self.db.profile.dropitem ) do
        local item = GetTable( TR, "id", i )

        item.name, _, item.qual = GetItemInfo( i )
        if( item.name ) then
            tinsert( temptbl, item )
            tbl2[i] = true
        else
            ReturnTable( TR, item )
        end--if
    end--for
    -- Add items in inventory with a qual over drop threshold or in keep sets/type and not in drop set/type
    
    local dropThreshold = self:GetDropThreshold()
    local IsItemInKeepSets = self.IsItemInKeepSets
    local IsItemKeepType = self.IsItemKeepType
   
    for _, i in ipairs( vars.items ) do
        if( ( not( i.notseen or tbl2[i.id] ) ) and ( i.totvalue > 0 ) and
                 ( ( i.qual > dropThreshold ) or IsItemInKeepSets( self, i.id ) or IsItemKeepType( self, i ) ) ) then
            local item = GetTable( TR,
                "id", i.id,
                "name", i.name,
                "qual", i.qual )

            tinsert( temptbl, item )
            tbl2[i.id] = true
        end---if
    end
    TR:ReturnTable( tbl2 )
    table.sort( temptbl, function( a, b ) return a.name < b.name end )
    return temptbl
end--Broker_GarbageFu:GetDropItemTable()

function Broker_GarbageFu:GetKeepItemTable()
    local vars = self.vars
    local temptbl = self.vars.temptbl
    TR:ClearTable( temptbl )

    local tbl2 = TR:GetTable()
    local GetTable = TR.GetTable
    local ReturnTable = TR.ReturnTable

    -- Start with itemid's listed as keep
    for i, _ in pairs( self.db.profile.keepitem ) do
        local item = TR:GetTable( "id", i )

        item.name, _, item.qual = GetItemInfo( i )
        if( item.name ) then
            tinsert( temptbl, item )
            tbl2[i] = true
        else
            ReturnTable( TR, item )
        end--if
    end--for
    
    local dropThreshold = self:GetDropThreshold()
    local IsItemInKeepSets = self.IsItemInKeepSets
    local IsItemKeepType = self.IsItemKeepType
    
    -- Add items in inventory with a qual less than or equal to drop threshold or in drop sets/type.
    for _, i in ipairs( vars.items ) do
        if( ( ( i.qual <= self:GetDropThreshold() ) or self:IsItemInDropSets( i.id ) or self:IsItemDropType( i ) ) and
                ( not ( i.notseen  or tbl2[i.id] or
                self:IsItemInKeepSets( i.id ) or self:IsItemKeepType( i ) ) ) ) then
            local item = TR:GetTable( TR,
                "id", i.id,
                "name", i.name,
                "qual", i.qual )

            if( not item.qual ) then
                self:MyPrint( "GetKeepItemTable: Item %d no quality?", i.id )
            end--if

            tinsert( temptbl, item )
            tbl2[i.id] = true
        end--if
    end--for
    TR:ReturnTable( tbl2 )
    table.sort( temptbl, function( a, b ) return a.name < b.name end )
    return temptbl
end--Broker_GarbageFu:GetKeepItemTable()

function Broker_GarbageFu:KeepFirstItem()
    local item = self:GetFirstDroppableItem()

    if( item ) then
        self:KeepItem( item )
    end--if
end--Broker_GarbageFu:KeepFirstItem()

function Broker_GarbageFu:GetDropItemAndItemTable()
    local vars = self.vars
    local temptbl = vars.temptbl

    TR:ClearTable( temptbl )

    local tbl2 = TR:GetTable()
    local GetTable = TR.GetTable
    local ReturnTable = TR.ReturnTable

    -- Start with itemid's listed as drop
    for i, _ in pairs( self.db.profile.dropitem ) do
        local item = GetTable( TR, "id", i )

        item.name, _, item.qual = GetItemInfo( i )
        if( item.name ) then
            tinsert( temptbl, item )
            tbl2[i] = true
        else
            ReturnTable( TR, item )
        end--if
    end--for
    
    -- Add items in inventory which have a value
    local IsItemInKeepSets = self.IsItemInKeepSets
    local IsItemKeepType = self.IsItemKeepType
   
    for _, i in ipairs( vars.items ) do
        if( ( not( i.notseen or tbl2[i.id] ) ) and ( i.totvalue > 0 ) and
                 ( IsItemInKeepSets( self, i.id ) or IsItemKeepType( self, i ) ) ) then
            local item = GetTable( TR,
                "id", i.id,
                "name", i.name,
                "qual", i.qual )

            tinsert( temptbl, item )
            tbl2[i.id] = true
        end---if
    end
    TR:ReturnTable( tbl2 )
    table.sort( temptbl, function( a, b ) return a.name < b.name end )
    return temptbl
end--Broker_GarbageFu:GetDropItemTable()

function Broker_GarbageFu:KeepItem( item )
    if( item ) then
        self:ToggleKeepItem( item.id )
        self:MyPrint( L["Adding %s to keep item list"], item.link )
    end--if
end--Broker_GarbageFu:KeepItem( item )

function Broker_GarbageFu:DropFirstItem()
    local item = self:GetFirstDroppableItem()

    if( item ) then
        self:DropItem( item )
    end--if
end--Broker_GarbageFu:DropFirstItem()

function Broker_GarbageFu:DropItem( item )
    if( not ( item and item.bag and item.slot and self:CheckItem( item ) and self:IsSafeToDelete() ) ) then
        return
    end--if

    if( self:IsItemDroppable( item ) ) then
        if( MerchantFrame:IsVisible() ) then
            self:MyPrint( L["Selling x%s %s worth %s"], item.stack, item.name, self:GetMoneyString( item.totvalue ) )
            --    Added by Scott update the DB with the value of the garbage item sold
            self.db.realm.garbageprofit[UnitName( "player" )] = self.db.realm.garbageprofit[UnitName( "player" )] + item.totvalue
            UseContainerItem( item.bag, item.slot )
            self:SetSafeToDelete( false )
        else
            self:MyPrint( L["Dropping x%s %s worth %s"], item.stack, item.name, self:GetMoneyString( item.totvalue ) )
            --    Added by Scott update the DB with the value of the garbage item dropped
            self.db.realm.garbagedropped[UnitName( "player" )] = self.db.realm.garbagedropped[UnitName( "player" )] + item.totvalue
            PickupContainerItem( item.bag, item.slot )
            DeleteCursorItem()
            self:SetSafeToDelete( false )
        end--if
    end--if
end--Broker_GarbageFu:DropItem( item )

function Broker_GarbageFu:SettingsReset()
    self:ResetDB( "profile" )
    self:ResetDB( "global" )
    table.wipe( self.vars.dropsets )
    table.wipe( self.vars.keepsets )
    table.wipe( self.vars.auctionsets )
    self:UpdateDisplay()
end--Broker_GarbageFu:SettingsReset()

function Broker_GarbageFu:GetMoneyString( value )
    if( ( not value ) or ( value == 0 ) ) then
        return "|cffffcc00??|r" -- No price
    elseif( self.db.profile.moneyformat == 1 ) then
        return abacus:FormatMoneyCondensed( value, true, true )
    elseif( self.db.profile.moneyformat == 2 ) then
        return abacus:FormatMoneyShort( value, true, true )
    elseif( self.db.profile.moneyformat == 3 ) then
        return abacus:FormatMoneyFull( value, true, true )
    else
        return abacus:FormatMoneyExtended( value, true, true )
    end--if
end--Broker_GarbageFu:GetMoneyString( value )

------------------------------------------------------------------------------------------------------
-- Sets functions
------------------------------------------------------------------------------------------------------

-- Converts self.db.profile.dropsets into self.vars.dropsets
-- Needed because self.db.profile.dropsets is index by name and self.vars.dropsets needs to be indexed by number with names as string.
function Broker_GarbageFu:MakeSetsTables()
    local vars = self.vars
    local profile = self.db.profile
    local dropsets = vars.dropsets

    table.wipe( dropsets )
    for n, _ in pairs( profile.dropsets ) do
        tinsert( dropsets, n )
    end--for

    local keepsets = vars.keepsets

    table.wipe( keepsets )
    for n, _ in pairs( profile.keepsets ) do
        tinsert( keepsets, n )
    end--for
end--Broker_GarbageFu:MakeSetsTables()

function Broker_GarbageFu:IsItemInSet( itemId, set )
    if( set and ( type( set ) == "table" ) ) then
        for s, v in pairs( set ) do
            local val, rset = PT3:ItemInSet( itemId, v )
            if( val ) then
                return true
            end--if
        end--for
    end--if
    return false
end--Broker_GarbageFu:IsItemInSet( itemId, set )

function Broker_GarbageFu:IsSetSelected( set, subset, setstbl )
    local setid = self.vars.sets[set].id

    if( subset ) then
        return setstbl[setid] or setstbl[self.vars.sets[set].sub[subset].id]
    end--if
    return setstbl[setid]
end--Broker_GarbageFu:IsSetSelected( set, subset, setstbl )

function Broker_GarbageFu:IsChildSetSelected( set, setstbl )
    if( self.vars.sets[set].sub ) then
        for _, s in ipairs( self.vars.sets[set].sub ) do
            if( setstbl[s.id] ) then
                return true
            end--if
        end--for
    end--if
    return false
end--Broker_GarbageFu:IsChildSetSelected( set, setstbl )

function Broker_GarbageFu:ToggleSets( set, subset, vartbl, setstbl1, setstbl2 )
    self:DebugPrint( ("ToggleSets(set) set=%s subset=%s"):format( tostring( set ), tostring( subset ) ) )
    local setid = vartbl[set].id

    if( subset ) then -- Clicked a child
        local subsetid = vartbl[set].sub[subset].id

        if( setstbl1[setid] ) then -- Check if parent is set
            setstbl1[setid] = nil -- Clear parent
            for _, s in ipairs( vartbl[set].sub ) do
                setstbl1[s.id] = true -- Set all children
            end--for
        end--if
        if( setstbl1[subsetid] ) then -- Reverse child
            setstbl1[subsetid] = nil
        else
            setstbl1[subsetid] = true
        end--if

        local allset = true

        for _, s in ipairs( vartbl[set].sub ) do
            if( not setstbl1[s.id] ) then -- Check if all children are set
                allset = false
                break
            end--if
        end--for
        if( allset ) then -- All children are set
            setstbl1[setid] = true -- set parent
            for i, s in ipairs( vartbl[set].sub ) do
                setstbl1[s.id] = nil -- And clear all children
            end--for
        end--if
    else -- Clicked a parent or a single
        if( setstbl1[setid] ) then -- Reverse it
            setstbl1[setid] = nil
        else
            setstbl1[setid] = true
            if( vartbl[set].sub ) then -- If it is a parent
                for _, s in ipairs( vartbl[set].sub ) do -- Clear all children for both setstbl1 and setstbl2
                    setstbl1[s.id] = nil
                    if( setstbl2 ) then
                        setstbl2[s.id] = nil
                    end--if
                end--for
            end--if
        end--if
    end--if
end--Broker_GarbageFu:ToggleSets( set, subset, vartbl, setstbl1, setstbl2 )

-- Check if item is in one of the sets selected for drop.
function Broker_GarbageFu:IsItemInDropSets( itemid )
    return self:IsItemInSet( itemid, self.vars.dropsets )
end--Broker_GarbageFu:IsItemInDropSets( itemid )

-- Check if item is in one of the sets selected for keep.
function Broker_GarbageFu:IsItemInKeepSets( itemid )
    return self:IsItemInSet( itemid, self.vars.keepsets )
end--Broker_GarbageFu:IsItemInKeepSets( itemid )

function Broker_GarbageFu:IsItemDropItem( itemid )
    return self.db.profile.dropitem[itemid] ~= nil
end--Broker_GarbageFu:IsItemDropItem( itemid )

function Broker_GarbageFu:IsItemKeepItem( itemid )
    return self.db.profile.keepitem[itemid] ~= nil
end--Broker_GarbageFu:IsItemKeepItem( itemid )

function Broker_GarbageFu:IsDropSetSelected( set, subset )
    return self:IsSetSelected( set, subset, self.db.profile.dropsets )
end--Broker_GarbageFu:IsDropSetSelected( set, subset )

function Broker_GarbageFu:IsKeepSetSelected( set, subset )
    return self:IsSetSelected( set, subset, self.db.profile.keepsets )
end--Broker_GarbageFu:IsKeepSetSelected( set, subset )

function Broker_GarbageFu:IsChildDropSetSelected( set )
    return self:IsChildSetSelected( set, self.db.profile.dropsets )
end--Broker_GarbageFu:IsChildDropSetSelected( set )

function Broker_GarbageFu:IsChildKeepSetSelected( set )
    return self:IsChildSetSelected( set, self.db.profile.keepsets )
end--Broker_GarbageFu:IsChildKeepSetSelected( set )

function Broker_GarbageFu:ToggleDropSet( set, subset )
    self:ToggleSets( set, subset, self.vars.sets, self.db.profile.dropsets, self.db.profile.keepsets )
    self:MakeSetsTables()
    self:UpdateDisplay()
end--Broker_GarbageFu:ToggleDropSet( set, subset )

function Broker_GarbageFu:ToggleKeepSet( set, subset )
    self:ToggleSets( set, subset, self.vars.sets, self.db.profile.keepsets, self.db.profile.dropsets )
    self:MakeSetsTables()
    self:UpdateDisplay()
end--Broker_GarbageFu:ToggleKeepSet( set, subset )

------------------------------------------------------------------------------------------------------
-- Special bag functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:GetBagId( bag )
    return self:GetItemId( GetInventoryItemLink( "player", ContainerIDToInventoryID( bag ) ) )
end--Broker_GarbageFu:GetBagId( bag )

function Broker_GarbageFu:IgnoreBag( bag )
    if( ( bag < 1 ) or ( bag > NUM_BAG_SLOTS ) ) then
        return
    end--if

    local bagId = self:GetBagId( bag )

    if( not bagId ) then
        return
    end--if

    local _, _, _, _, _, bagtype, bagsubtype = GetItemInfo( bagId )

    return ( self:IsIgnoringHerbBag() and ( bagsubtype == LBI["Herb Bag"] ) ) or
           ( self:IsIgnoringEnchBag() and ( bagsubtype == LBI["Enchanting Bag"] ) ) or
           ( self:IsIgnoringEngBag() and ( bagsubtype == LBI["Engineering Bag"] ) ) or
           ( self:IsIgnoringFishBag() and ( bagsubtype == LBI["Tackle Box"] ) ) or
           ( self:IsIgnoringGemBag() and ( bagsubtype == LBI["Gem Bag"] ) ) or
           ( self:IsIgnoringInsBag() and ( bagsubtype == LBI["Inscription Bag"] ) ) or
           ( self:IsIgnoringLeatherBag() and ( bagsubtype == LBI["Leatherworking Bag"] ) ) or
           ( self:IsIgnoringMinBag() and ( bagsubtype == LBI["Mining Bag"] ) )
end--Broker_GarbageFu:IgnoreBag( bag )

------------------------------------------------------------------------------------------------------
-- Item Price functions
------------------------------------------------------------------------------------------------------

-- Update all items in the inventory with new prices.
function Broker_GarbageFu:UpdateAllItemValues()
    for _, item in ipairs( self.vars.items ) do
        self:GetItemValue( item )
    end--for
    self:SortItems()
end--Broker_GarbageFu:UpdateAllItemValues()

-- Updates all occurances of itemid in the inventory with a new price.
function Broker_GarbageFu:UpdateItemValue( itemid )
    for _, item in ipairs( self.vars.items ) do
        if( item.id == itemid ) then
            self:GetItemValue( item )
        end--if
    end--for
    self:SortItems()
end--Broker_GarbageFu:UpdateItemValue( itemid )

-- Get item value.
function Broker_GarbageFu:GetItemValue( item )
--    if( not self:GetAuctionValue( item ) ) then
        self:GetVendorValue( item )
--    end--if
end--Broker_GarbageFu:GetItemValue( item )


------------------------------------------------------------------------------------------------------
-- Custom price override functions
------------------------------------------------------------------------------------------------------

-- Check that we got a numeric value from the editbox.
function Broker_GarbageFu:ValidateValue( value )
    self:DebugPrint( "ValidateValue value=" .. tostring( value ) )

    local res = ""

    for s in value:gmatch( "(%d*).-(%d*)" ) do
        res = res .. s
    end--for
    return res
end--Broker_GarbageFu:ValidateValue( value )

-- Stores a new User Override price for the top item.
function Broker_GarbageFu:SetFirstItemValue( value )
    local item = self:GetFirstDroppableItem()

    if( item ) then
        self:SetItemValue( self, item.id, value )
    end--if
end--Broker_GarbageFu:SetFirstItemValue( self, value )

-- Stores a new User Override price for an item, or removing it.
function Broker_GarbageFu.SetItemValue( self, itemid, value )
    value = tonumber( value )
    if( itemid ) then
        self:DebugPrint( "SetItemValue value=" .. tostring( value ) .. "itemid = " .. tostring( itemid ) )
        if( ( not value ) or ( value == 0 ) ) then
            if( self.db.global.overrideprices[itemid] ) then
                self.db.global.overrideprices[itemid] = nil
                self:MyPrint( L["Removing custom price for %s."], select( 1, GetItemInfo( itemid ) ) )
            end--if
        else
            self.db.global.overrideprices[itemid] = value
            self:MyPrint( L["Setting price for %s to %s."], select( 1, GetItemInfo( itemid ) ), self:GetMoneyString( value ) )
        end--if
        self:UpdateItemValue( itemid )
    end--if
end--Broker_GarbageFu.SetItemValue( self, itemid, value )

function Broker_GarbageFu:GetCustomItemValueTable()
    local tbl2 = TR:GetTable()

    self.vars.temptbl = TR:GetTable()
    -- Start with itemid's with a custom price
    for i, v in pairs( self.db.global.overrideprices ) do
        local item = TR:GetTable( "id", i, "value", v )

        item.name, _, item.qual = GetItemInfo( i )
        if( item.name ) then
            tinsert( self.vars.temptbl, item )
            tbl2[i] = true
        else
            TR:ReturnTable( item )
        end--if
    end--for
    -- Add items in inventory. Not poor quality items that already have a price
    for _, i in ipairs( self.vars.items ) do
        if( ( ( i.qual > 0 ) or ( i.totvalue == 0 ) ) and ( not ( i.notseen or tbl2[i.id] or
                self:IsItemInKeepSets( i.id ) or self:IsItemKeepType( i ) or
                self:IsItemKeepItem( i.id ) ) ) ) then
            local item = TR:GetTable(
                "id", i.id,
                "name", i.name,
                "qual", i.qual,
                "value", i.value or 0 )

            if( not item.qual ) then
                self:MyPrint( "GetCustomItemValueTable: Item %d no quality?", i.id )
            end--if

            tinsert( self.vars.temptbl, item )
            tbl2[i.id] = true
        end--if
    end--for
    TR:ReturnTable( tbl2 )
    table.sort( self.vars.temptbl, function( a, b ) return a.name < b.name end )
    return self.vars.temptbl
end--Broker_GarbageFu:GetCustomItemValueTable()

------------------------------------------------------------------------------------------------------
-- Chat output functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:DebugPrint( a1, ... )
    if( self.CustomDebug ) then
        self:CustomDebug( 1, 0.5, 0, nil, nil, a1, ... )
    end--if
end--Broker_GarbageFu:DebugPrint( a1, ... )

function Broker_GarbageFu:MyPrint( a1, ... )
    textcolor = self.db.profile.textcolor

    self:Print( ("|cff%02x%02x%02x"):format( textcolor.r * 255, textcolor.g * 255, textcolor.b * 255 ), a1:format( ... ) )
end--Broker_GarbageFu:MyPrint( a1, ... )
