--[[
Copyright (c) 2008-2011, LordFarlander
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]--

-- $Revision: 30 $
-- $Date: 2011-12-24 04:23:38 +0000 (Sat, 24 Dec 2011) $
if( not Broker_GarbageFu ) then
    return
end--if
------------------------------------------------------------------------------------------------------
-- Item Type functions
------------------------------------------------------------------------------------------------------
local L = LibStub( "AceLocale-3.0" ):GetLocale( "Broker_GarbageFu" )
local dewdrop = LibStub( "Dewdrop-2.0" )
local gratuity = LibStub( "LibGratuity-3.0" )

function Broker_GarbageFu:InitTypes()
    local LBI = LibStub( "LibBabble-Inventory-3.0" ):GetUnstrictLookupTable()
    
    self.vars.itemtypes = {
        { id = "weapon_all", name = LBI["Weapon"], sub = {
            { id = "weapon_dagger", name = LBI["Daggers"] },
            { id = "weapon_fist", name = LBI["Fist Weapons"] },
            { id = "weapon_1haxe", name = LBI["One-Handed Axes"] },
            { id = "weapon_2hmace", name = LBI["One-Handed Maces"] },
            { id = "weapon_1hsword", name = LBI["One-Handed Swords"] },
            { id = "weapon_2haxe", name = LBI["Two-Handed Axes"] },
            { id = "weapon_2hmace", name = LBI["Two-Handed Maces"] },
            { id = "weapon_2hsword", name = LBI["Two-Handed Swords"] },
            { id = "weapon_polearm", name = LBI["Polearms"] },
            { id = "weapon_stave", name = LBI["Staves"] },
            { id = "weapon_bow", name = LBI["Bows"] },
            { id = "weapon_crossbow", name = LBI["Crossbows"] },
            { id = "weapon_gun", name = LBI["Guns"] },
            { id = "weapon_thrown", name = LBI["Thrown"] },
            { id = "weapon_wand", name = LBI["Wands"] },
            { id = "weapon_pole", name = LBI["Fishing Poles"] },
            { id = "weapon_misc", name = LBI["Miscellaneous"] },
         }, },
        { id = "armor_all", name = LBI["Armor"], sub = {
            { id = "armor_cloth", name = LBI["Cloth"] },
            { id = "armor_leather", name = LBI["Leather"] },
            { id = "armor_mail", name = LBI["Mail"] },
            { id = "armor_plate", name = LBI["Plate"] },
            { id = "armor_shield", name = LBI["Shields"] },
            { id = "armor_misc", name = LBI["Miscellaneous"] },
            { id = "armor_relics", name = LBI["Relics"] },
         }, },
        { id = "bag_all", name = LBI["Container"], sub = {
            { id = "bag_bag", name = LBI["Bag"] },
            { id = "bag_herb", name = LBI["Herb Bag"] },
            { id = "bag_enchanting", name = LBI["Enchanting Bag"] },
            { id = "bag_engineering", name = LBI["Engineering Bag"] },
            { id = "bag_gem", name = LBI["Gem Bag"] },
            { id = "bag_mining", name = LBI["Mining Bag"] },
            { id = "bag_leatherworking", name = LBI["Leatherworking Bag"] },
            { id = "bag_inscription", name = LBI["Inscription Bag"] },
            { id = "bag_fishing", name = LBI["Tackle Box"] },
         }, },
        { id = "recipe_all", name = LBI["Recipe"], sub = {
            { id = "recipe_alchemy", name = LBI["Alchemy"] },
            { id = "recipe_blacksmith", name = LBI["Blacksmithing"] },
            { id = "recipe_enchant", name = LBI["Enchanting"] },
            { id = "recipe_engineer", name = LBI["Engineering"] },
            { id = "recipe_leather", name = LBI["Leatherworking"] },
            { id = "recipe_tailor", name = LBI["Tailoring"] },
            { id = "recipe_cook", name = LBI["Cooking"] },
            { id = "recipe_firstaid", name = LBI["First Aid"] },
            { id = "recipe_book", name = LBI["Book"] },
            { id = "recipe__jewelcrafting", name = LBI["Jewelcrafting"] },
            { id = "recipe__inscription", name = LBI["Inscription"] },
         }, },
        { id = "consumable_all", name = LBI["Consumable"], sub = {
            { id = "consumable_food_drink", name = LBI["Food & Drink"] },
            { id = "consumable_potion", name = LBI["Potion"] },
            { id = "consumable_elixir", name = LBI["Elixir"] },
            { id = "consumable_flask", name = LBI["Flask"] },
            { id = "consumable_bandage", name = LBI["Bandage"] },
            { id = "consumable_itemenhancement", name = LBI["Item Enhancement"] },
            { id = "consumable_scroll", name = LBI["Scroll"] },
            { id = "consumable_other", name = LBI["Other"] },
         }, },
        { id = "glyph_all", name = LBI["Glyph"], sub = {
            { id = "glyph_warrior", name = LBI["Warrior"] },
            { id = "glyph_mage", name = LBI["Mage"] },
            { id = "glyph_rogue", name = LBI["Rogue"] },
            { id = "glyph_druid", name = LBI["Druid"] },
            { id = "glyph_hunter", name = LBI["Hunter"] },
            { id = "glyph_shaman", name = LBI["Shaman"] },
            { id = "glyph_priest", name = LBI["Priest"] },
            { id = "glyph_warlock", name = LBI["Warlock"] },
            { id = "glyph_paladin", name = LBI["Paladin"] },
            { id = "glyph_deathknight", name = LBI["Death Knight"] },
            --{ id = "glyph_monk", name = LBI["Monk"] },
         }, },
        { id = "tradegood_all", name = LBI["Trade Goods"], sub = {
            { id = "tradegood_elemental", name = LBI["Elemental"] },
            { id = "tradegood_cloth", name = LBI["Cloth"] },
            { id = "tradegood_leather", name = LBI["Leather"] },
            { id = "tradegood_metal_stone", name = LBI["Metal & Stone"] },
            { id = "tradegood_meat", name = LBI["Meat"] },
            { id = "tradegood_herb", name = LBI["Herb"] },
            { id = "tradegood_enchanting", name = LBI["Enchanting"] },
            { id = "tradegood_jewelcrafting", name = LBI["Jewelcrafting"] },
            { id = "tradegood_parts", name = LBI["Parts"] },
            { id = "tradegood_devices", name = LBI["Devices"] },
            { id = "tradegood_explosives", name = LBI["Explosives"] },
            { id = "tradegood_materials", name = LBI["Materials"] },
            { id = "tradegood_other", name = LBI["Other"] },
            { id = "tradegood_itemnchantment", name = LBI["Item Enchantment"] },
         }, },
        { id = "gem_all", name = LBI["Gem"], sub = {
            { id = "gem_red", name = LBI["Red"] },
            { id = "gem_blue", name = LBI["Blue"] },
            { id = "gem_yellow", name = LBI["Yellow"] },
            { id = "gem_purple", name = LBI["Purple"] },
            { id = "gem_green", name = LBI["Green"] },
            { id = "gem_orange", name = LBI["Orange"] },
            { id = "gem_meta", name = LBI["Meta"] },
            { id = "gem_simple", name = LBI["Simple"] },
            { id = "gem_prismatic", name = LBI["Prismatic"] },
            { id = "gem_cogwheel", name = LBI["Cogwheel"] },
         }, },
        { id = "miscallaneous_all", name = LBI["Miscallaneous"], sub = {
            { id = "miscallaneous_junk", name = LBI["Junk"] },
            { id = "miscallaneous_reagent", name = LBI["Reagent"] },
            { id = "miscallaneous_pet", name = LBI["Pet"] },
            { id = "miscallaneous_holiday", name = LBI["Holiday"] },
            { id = "miscallaneous_other", name = LBI["Other"] },
            { id = "miscallaneous_mount", name = LBI["Mount"] },
         }, },
        { id = "quest_all", name = LBI["Quest"] },
        { id = "S", name = ITEM_SOULBOUND, val = 32 },
        { id = "Q", name = ITEM_BIND_QUEST, val = 64 },
        { id = "E", name = ITEM_BIND_ON_EQUIP .. "/" .. ITEM_BIND_ON_USE, val = 128 },
        { id = "P", name = ITEM_BIND_ON_PICKUP, val = 256 },
        { id = "A", name = ITEM_BIND_TO_BNETACCOUNT, val = 512 },
    }

    self.vars.typesconverttbl = {
        ["weaponall"] = "weapon_all",
        ["weapondagger"] = "weapon_dagger",
        ["weaponfist"] = "weapon_fist",
        ["weapon1haxe"] = "weapon_1haxe",
        ["weapon2hmace"] = "weapon_2hmace",
        ["weapon1hsword"] = "weapon_1hsword",
        ["weapon2haxe"] = "weapon_2haxe",
        ["weapon2hmace"] = "weapon_2hmace",
        ["weapon2hsword"] = "weapon_2hsword",
        ["weaponpolearm"] = "weapon_polearm",
        ["weaponstave"] = "weapon_stave",
        ["weaponbow"] = "weapon_bow",
        ["weaponcrossbow"] = "weapon_crossbow",
        ["weapongun"] = "weapon_gun",
        ["weaponthrown"] = "weapon_thrown",
        ["weaponwand"] = "weapon_wand",
        ["weaponpole"] = "weapon_pole",
        ["weaponmisc"] = "weapon_misc",
        ["armorall"] = "armor_all",
        ["armorcloth"] = "armor_cloth",
        ["armorleather"] = "armor_leather",
        ["armormail"] = "armor_mail",
        ["armorplate"] = "armor_plate",
        ["armorshield"] = "armor_shield",
        ["armoridol"] = "armor_idol",
        ["armortotem"] = "armor_totem",
        ["armorlibram"] = "armor_relic",
        ["armormisc"] = "armor_misc",
        ["armoridol"] = "armor_relic",
        ["armortotem"] = "armor_relic",
        ["armorlibram"] = "armor_relic",
        ["bag"] = "bag_all",
        ["recipeall"] = "recipe_all",
        ["recipealchemy"] = "recipe_alchemy",
        ["recipeblacksmith"] = "recipe_blacksmith",
        ["recipeenchant"] = "recipe_enchant",
        ["recipeengineer"] = "recipe_engineer",
        ["recipeleather"] = "recipe_leather",
        ["recipetailor"] = "recipe_tailor",
        ["recipecook"] = "recipe_cook",
        ["recipefirstaid"] = "recipe_firstaid",
        ["recipebook"] = "recipe_book",
    }
    self.vars.typesdeprecatedtbl = {
        ["ammoall"] = true,
        ["ammoarrow"] = true,
        ["ammobullet"] = true,
        ["key"] = true,
    }
end--Broker_GarbageFu:InitTypes()

-- Upgrade set names
function Broker_GarbageFu:TypeUpgradeSetName( setid, profileset )
    -- Some types get depricated over time
    -- Also type ids changed to make them easier to read
    local typesconverttbl = self.vars.typesconverttbl
    local typesdeprecatedtbl = self.vars.typesdeprecatedtbl

    if( typesconverttbl[setid] ) then
        profileset[typesconverttbl[setid]] = true
    elseif( typesdeprecatedtbl[setid] ) then
        profileset[typesdeprecatedtbl[setid]] = false
    end--if
end--Broker_GarbageFu:TypeUpgradeSetName( setid, profileset )

function Broker_GarbageFu:GetItemType( item )
    gratuity:SetBagItem( item.bag, item.slot )

    local Find = gratuity.Find

    item.bind = ""
    if( Find( gratuity, ITEM_SOULBOUND, 2, 4, false, true, false ) ) then
        item.bind = item.bind .. "S" -- Soulbound
        gratuity:SetHyperlink( "item:" .. item.code )
    end--if
    if( Find( gratuity, ITEM_BIND_QUEST, 2, 4, false, true, false ) ) then
        item.bind = item.bind .. "Q" -- Quest
    elseif( Find( gratuity, ITEM_BIND_ON_PICKUP, 2, 4, false, true, false ) ) then
        item.bind = item.bind .. "P" -- Pickup
    elseif( Find( gratuity, ITEM_BIND_ON_EQUIP, 2, 4, false, true, false ) or
            Find( gratuity, ITEM_BIND_ON_USE, 2, 4, false, true, false ) ) then
        item.bind = item.bind .. "E" -- BoE
    elseif( Find( gratuity, ITEM_BIND_TO_BNETACCOUNT, 2, 4, false, true, false ) or
            Find( gratuity, ITEM_BIND_TO_ACCOUNT, 2, 4, false, true, false ) ) then
        item.bind = item.bind .. "A" -- BoA
    end--if
    if( item.bind:len() == 0 ) then
        item.bind = nil
    end--if

    local iType, iSubType

    _, _, item.qual, _, _, iType, iSubType, item.maxstack, _, item.tex = GetItemInfo( item.id )
    if( iType ) then
        for i, n in ipairs( self.vars.itemtypes ) do
            if( not( n.val ) and ( iType == n.name ) ) then
                item.type = i
                if( n.sub ) then
                    for i2, n2 in ipairs( n.sub ) do
                        if( iSubType == n2.name ) then
                            item.subtype = i2
                            break
                        end--if
                    end--for
                end--if
                break
            end--if
        end--for
    end--if
end--Broker_GarbageFu:GetItemType( item )

function Broker_GarbageFu:IsItemSoulbound( item )
    return item.bind and ( ( item.bind:find( "S" ) ~= nil ) and ( item.bind:find( "Q" ) ~= nil ) )
end--Broker_GarbageFu:IsItemSoulbound( item )

function Broker_GarbageFu:IsItemDropType( item )
    return self:IsItemType( item, self.db.profile.droptypes )
end--Broker_GarbageFu:IsItemDropType( item )

function Broker_GarbageFu:IsItemKeepType( item )
    return self:IsItemType( item, self.db.profile.keeptypes )
end--Broker_GarbageFu:IsItemKeepType( item )

function Broker_GarbageFu:IsDropTypeSelected( i, i2 )
    return self:IsTypeSelected( i, i2, self.db.profile.droptypes )
end--Broker_GarbageFu:IsDropTypeSelected( i, i2 )

function Broker_GarbageFu:IsKeepTypeSelected( i, i2 )
    return self:IsTypeSelected( i, i2, self.db.profile.keeptypes )
end--Broker_GarbageFu:IsKeepTypeSelected( i, i2 )

function Broker_GarbageFu:IsChildDropTypeSelected( i )
    return self:IsChildTypeSelected( i, self.db.profile.droptypes )
end--Broker_GarbageFu:IsChildDropTypeSelected( i )

function Broker_GarbageFu:IsChildKeepTypeSelected( i )
    return self:IsChildTypeSelected( i, self.db.profile.keeptypes )
end--Broker_GarbageFu:IsChildKeepTypeSelected( i )

function Broker_GarbageFu:ToggleDropType( i, i2 )
    self:ToggleSets( i, i2, self.vars.itemtypes, self.db.profile.droptypes, self.db.profile.keeptypes )
    self:UpdateDisplay()
end--Broker_GarbageFu:ToggleDropType( i, i2 )

function Broker_GarbageFu:ToggleKeepType( i, i2 )
    self:ToggleSets( i, i2, self.vars.itemtypes, self.db.profile.keeptypes, self.db.profile.droptypes )
    self:UpdateDisplay()
end--Broker_GarbageFu:ToggleKeepType( i, i2 )

function Broker_GarbageFu:BuildDropTypeMenu( level, value, inTooltip, value2 )
    local AddLine = dewdrop.AddLine

    if( level == 1 ) then
        AddLine( dewdrop, "text", L["Drop Types"], "hasArrow", true, "value", "droptypes" )
    elseif( level == 2 ) then
        if( value == "droptypes" ) then
            -- Drop - Types
            local IsDropTypeSelected = self.IsDropTypeSelected
            local IsKeepTypeSelected = self.IsKeepTypeSelected

            AddLine( dewdrop, "text", L["Drop Types"], "isTitle", true )
            for n, i in ipairs( self.vars.itemtypes ) do
                local checked = IsDropTypeSelected( self, n )
                local checkIcon = [[Interface\Buttons\UI-CheckBox-Check]]

                if( self:IsChildDropTypeSelected( n ) ) then
                    checked = true
                    checkIcon = [[Interface\Buttons\UI-CheckBox-Check-Disabled]]
                end--if
                AddLine( dewdrop, "text", i.name,
                    "checked", checked, "checkIcon", checkIcon,
                    "disabled", IsKeepTypeSelected( self, n ),
                    "hasArrow", i.sub ~= nil, "value", n,
                    "arg1", self, "arg2", n, "func", "ToggleDropType" )
            end--for
        end--if
    elseif( level == 3 ) then
        if( value2 == "droptypes" ) then
            local IsDropTypeSelected = self.IsDropTypeSelected
            local IsKeepTypeSelected = self.IsKeepTypeSelected

            AddLine( dewdrop, "text", L["Drop Type"] .. " " .. self.vars.itemtypes[value].name, "isTitle", true )
            for n, i in ipairs( self.vars.itemtypes[value].sub ) do
                AddLine( dewdrop, "text", i.name,
                    "checked", IsDropTypeSelected( self, value, n ),
                    "disabled", IsKeepTypeSelected( self, value, n ),
                    "arg1", self, "arg2", value, "arg3", n, "func", "ToggleDropType" )
            end--for
        end--if
    end--if
end--Broker_GarbageFu:BuildDropTypeMenu( level, value, inTooltip, value2 )

function Broker_GarbageFu:BuildKeepTypeMenu( level, value, inTooltip, value2 )
    local AddLine = dewdrop.AddLine

    if( level == 1 ) then
        AddLine( dewdrop, "text", L["Keep Types"], "hasArrow", true, "value", "keeptypes" )
    elseif( level == 2 ) then
        if( value == "keeptypes" ) then
            -- Keep - Types
            local IsKeepTypeSelected = self.IsKeepTypeSelected
            local IsDropTypeSelected = self.IsDropTypeSelected

            AddLine( dewdrop, "text", L["Keep Types"], "isTitle", true )
            for n, i in ipairs( self.vars.itemtypes ) do
                local checked = IsKeepTypeSelected( self, n )
                local checkIcon = [[Interface\Buttons\UI-CheckBox-Check]]

                if( self:IsChildKeepTypeSelected( n ) ) then
                    checked = true
                    checkIcon = [[Interface\Buttons\UI-CheckBox-Check-Disabled]]
                end--if
                AddLine( dewdrop, "text", i.name,
                    "checked", checked, "checkIcon", checkIcon,
                    "disabled", IsDropTypeSelected( self, n ),
                    "hasArrow", i.sub ~= nil, "value", n,
                    "arg1", self, "arg2", n, "func", "ToggleKeepType" )
            end--for
        end--if
    elseif( level == 3 ) then
        if( value2 == "keeptypes" ) then
            local IsKeepTypeSelected = self.IsKeepTypeSelected
            local IsDropTypeSelected = self.IsDropTypeSelected

            AddLine( dewdrop, "text", L["Keep Type"] .. " " .. self.vars.itemtypes[value].name and self.vars.itemtypes[value].name or value, "isTitle", true )
            for n, i in ipairs( self.vars.itemtypes[value].sub ) do
                AddLine( dewdrop, "text", i.name,
                    "checked", IsKeepTypeSelected( self, value, n ),
                    "disabled", IsDropTypeSelected( self, value, n ),
                    "arg1", self, "arg2", value, "arg3", n, "func", "ToggleKeepType" )
            end--for
        end--if
    end--if
end--Broker_GarbageFu:BuildKeepTypeMenu( level, value, inTooltip, value2 )

function Broker_GarbageFu:IsItemType( item, typestbl )
    if( item.type ) then
        if( typestbl[self.vars.itemtypes[item.type].id] ) then
            return true
        elseif( item.subtype ) then
            if( typestbl[self.vars.itemtypes[item.type].sub[item.subtype].id] ) then
                return true
            end--if
        end--if
    end--if
    if( item.bind ) then
        for i = 1, item.bind:len() do
            if( typestbl[item.bind:sub( i, i )] ) then
                return true
            end--if
        end--if
    end--if
    return false
end--Broker_GarbageFu:IsItemType( item, typestbl )

function Broker_GarbageFu:IsTypeSelected( i, i2, typestbl )
    local typeid = self.vars.itemtypes[i].id

    if( i2 ) then
        local subtypeid = self.vars.itemtypes[i].sub[i2].id

        return typestbl[typeid] or typestbl[subtypeid]
    end--if
    return typestbl[typeid]
end--Broker_GarbageFu:IsTypeSelected( i, i2, typestbl )

function Broker_GarbageFu:IsChildTypeSelected( i, typestbl )
    if( self.vars.itemtypes[i].sub ) then
        for _, s in ipairs( self.vars.itemtypes[i].sub ) do
            if( typestbl[s.id] ) then
                return true
            end--if
        end--for
    end--if
end--Broker_GarbageFu:IsChildTypeSelected( i, typestbl )
